'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCLEV.BI'

REM $DYNAMIC
SUB LoadBIT

BIT$ = CHR$(Header71(4)) + CHR$(Header71(5))
LoadBSV 11, "BITS\" + BIT$ + ".BIT"
FOR I = 0 TO 63
PALpcw I + 64, DQBpoint(11, I, 197), DQBpoint(11, I, 198), DQBpoint(11, I, 199)
NEXT
PALreset

END SUB

SUB LoadFromMap (X, Y)

' Load header stuff
XX = X * 18
YY = Y * 2 + 160
FOR Y1 = YY TO YY + 1
FOR X1 = XX TO XX + 17
Header71(C) = DQBpoint(6, X1, Y1)
Header71(C + 36) = DQBpoint(7, X1, Y1)
P = DQBpoint(8, X1, Y1)
IF P > 31 THEN A$ = A$ + CHR$(P)
C = C + 1
NEXT
NEXT
Desc$ = A$

' Load map data from maps
FOR Y1 = 0 TO (Header71(3) * 10) - 1
FOR X1 = 0 TO (Header71(2) * 18) - 1
XX1 = X1 + (Header71(0) * 18)
YY1 = Y1 + (Header71(1) * 10)
CMap(X1, Y1) = CHR$(DQBpoint(6, XX1, YY1))
TMap(X1, Y1, 0) = DQBpoint(7, XX1, YY1) + (DQBpoint(8, XX1, YY1) * 256)
TMap(X1, Y1, 1) = DQBpoint(9, XX1, YY1) + (DQBpoint(10, XX1, YY1) * 256)
NEXT
NEXT

' Editor coordinates
DA(17) = 0
DA(18) = 0
DA(59) = 0
DA(60) = 0

END SUB

REM $STATIC
SUB Loading

' Main Font
IF DQBloadFont("SMALL.FNT") THEN IErrorEND ""

' Main settings
A$ = SPACE$(128)
OPEN "CCLEVLED.INI" FOR BINARY AS #1
IF LOF(1) <> 128 THEN IErrorEND "CCLEVLED.INI is either missing or corrupt"
GET #1, , A$
CLOSE #1
FOR I = 0 TO 63
DA(I) = CVI(MID$(A$, I * 2 + 1, 2))
NEXT

' Main Images
FOR I = 1 TO 4
LoadBSV I, "MAINPAGE\" + CHR$(I + 64) + ".PAG"
NEXT
DQBget 1, 176, 152, 191, 167, VARSEG(MouseGFX(0)), VARPTR(MouseGFX(0))
' Load it for icons
LoadBSV 5, "SAVEDATA.SAV"

' Main Palettes
FOR I = 0 TO 23
PALpcw I, DQBpoint(1, I, 197), DQBpoint(1, I, 198), DQBpoint(1, I, 199)
PALpcw I + 24, DQBpoint(2, I, 197), DQBpoint(2, I, 198), DQBpoint(2, I, 199)
NEXT
FOR I = 0 TO 15
PALpcw I + 48, DQBpoint(3, I, 197), DQBpoint(3, I, 198), DQBpoint(3, I, 199)
NEXT
FOR I = 0 TO 31
PALpcw I + 192, DQBpoint(4, I, 197), DQBpoint(4, I, 198), DQBpoint(4, I, 199)
NEXT
PALpcw 253, 63, 0, 0
PALpcw 254, 0, 63, 0
PALpcw 255, 0, 0, 63
PALreset

' Main sprites for map
DQBget 1, 0, 120, 7, 127, VARSEG(AGets(0, 1)), VARPTR(AGets(0, 1))
DQBget 1, 0, 128, 7, 135, VARSEG(AGets(0, 2)), VARPTR(AGets(0, 2))
DQBget 1, 8, 128, 15, 135, VARSEG(AGets(0, 3)), VARPTR(AGets(0, 3))
DQBget 1, 8, 120, 15, 127, VARSEG(AGets(0, 4)), VARPTR(AGets(0, 4))
DQBget 1, 56, 120, 63, 127, VARSEG(AGets(0, 5)), VARPTR(AGets(0, 5))
DQBget 1, 56, 128, 63, 135, VARSEG(AGets(0, 6)), VARPTR(AGets(0, 6))
DQBget 1, 48, 120, 55, 127, VARSEG(AGets(0, 7)), VARPTR(AGets(0, 7))
DQBget 1, 48, 128, 55, 135, VARSEG(AGets(0, 8)), VARPTR(AGets(0, 8))
DQBget 1, 16, 120, 23, 127, VARSEG(AGets(0, 9)), VARPTR(AGets(0, 9))
DQBget 1, 24, 120, 31, 127, VARSEG(AGets(0, 10)), VARPTR(AGets(0, 10))
DQBget 1, 16, 128, 23, 135, VARSEG(AGets(0, 11)), VARPTR(AGets(0, 11))
DQBget 1, 24, 128, 31, 135, VARSEG(AGets(0, 12)), VARPTR(AGets(0, 12))
DQBget 1, 40, 128, 47, 135, VARSEG(AGets(0, 13)), VARPTR(AGets(0, 13))
DQBget 1, 32, 128, 39, 135, VARSEG(AGets(0, 14)), VARPTR(AGets(0, 14))
DQBget 1, 32, 120, 39, 127, VARSEG(AGets(0, 15)), VARPTR(AGets(0, 15))
DQBget 1, 40, 120, 47, 127, VARSEG(AGets(0, 16)), VARPTR(AGets(0, 16))
DQBget 1, 0, 136, 7, 143, VARSEG(AGets(0, 17)), VARPTR(AGets(0, 17))
DQBget 1, 8, 136, 15, 143, VARSEG(AGets(0, 18)), VARPTR(AGets(0, 18))

' Drawing icons for graphics editing
DQBget 1, 48, 192, 79, 199, VARSEG(Buttons(0, 0)), VARPTR(Buttons(0, 0))
DQBget 1, 112, 192, 143, 199, VARSEG(Buttons(0, 1)), VARPTR(Buttons(0, 1))
DQBget 1, 80, 192, 111, 199, VARSEG(Buttons(0, 2)), VARPTR(Buttons(0, 2))
DQBget 1, 144, 192, 175, 199, VARSEG(Buttons(0, 3)), VARPTR(Buttons(0, 3))
DQBget 1, 256, 72, 287, 79, VARSEG(Buttons(0, 4)), VARPTR(Buttons(0, 4))
DQBget 1, 288, 72, 319, 79, VARSEG(Buttons(0, 5)), VARPTR(Buttons(0, 5))
DQBget 1, 256, 80, 287, 87, VARSEG(Buttons(0, 6)), VARPTR(Buttons(0, 6))
DQBget 1, 288, 80, 319, 87, VARSEG(Buttons(0, 7)), VARPTR(Buttons(0, 7))
DQBget 4, 160, 144, 191, 151, VARSEG(Buttons(0, 8)), VARPTR(Buttons(0, 8))
DQBget 4, 160, 152, 191, 159, VARSEG(Buttons(0, 9)), VARPTR(Buttons(0, 9))
DQBget 5, 272, 0, 287, 15, VARSEG(Buttons(0, 10)), VARPTR(Buttons(0, 10))
 DQBget 5, 288, 0, 300, 12, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 11)), VARPTR(Buttons(0, 11))
DQBget 4, 160, 128, 175, 143, VARSEG(Buttons(0, 12)), VARPTR(Buttons(0, 12))
DQBget 4, 176, 128, 191, 143, VARSEG(Buttons(0, 13)), VARPTR(Buttons(0, 13))
 DQBget 5, 96, 84, 108, 96, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 14)), VARPTR(Buttons(0, 14))
 DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 15)), VARPTR(Buttons(0, 15))
 DQBget 5, 96, 97, 108, 109, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 16)), VARPTR(Buttons(0, 16))
  DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 17)), VARPTR(Buttons(0, 17))
  DQBget 5, 96, 58, 108, 70, VARSEG(QPut(0)), VARPTR(QPut(0))
  DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 18)), VARPTR(Buttons(0, 18))
  DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 19)), VARPTR(Buttons(0, 19))
  DQBget 5, 96, 71, 108, 83, VARSEG(QPut(0)), VARPTR(QPut(0))
  DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 20)), VARPTR(Buttons(0, 20))
  DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 21)), VARPTR(Buttons(0, 21))
 DQBget 4, 160, 112, 175, 127, VARSEG(Buttons(0, 22)), VARPTR(Buttons(0, 22))
 DQBget 4, 176, 112, 191, 127, VARSEG(Buttons(0, 23)), VARPTR(Buttons(0, 23))
 DQBget 4, 144, 128, 159, 143, VARSEG(Buttons(0, 24)), VARPTR(Buttons(0, 24))
 DQBget 4, 144, 144, 159, 159, VARSEG(Buttons(0, 25)), VARPTR(Buttons(0, 25))
  DQBget 5, 96, 45, 108, 57, VARSEG(QPut(0)), VARPTR(QPut(0))
  DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 26)), VARPTR(Buttons(0, 26))
 DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 27)), VARPTR(Buttons(0, 27))
 DQBget 5, 96, 32, 108, 44, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 28)), VARPTR(Buttons(0, 28))
 DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 29)), VARPTR(Buttons(0, 29))
DQBget 1, 240, 168, 255, 183, VARSEG(Buttons(0, 30)), VARPTR(Buttons(0, 30))
DQBget 1, 240, 184, 255, 199, VARSEG(Buttons(0, 31)), VARPTR(Buttons(0, 31))
DQBget 5, 208, 0, 223, 15, VARSEG(Buttons(0, 32)), VARPTR(Buttons(0, 32))
DQBget 5, 224, 0, 239, 15, VARSEG(Buttons(0, 33)), VARPTR(Buttons(0, 33))
FOR I = 0 TO 6
DQBget 5, 304, 80 + (I * 13), 316, 92 + (I * 13), VARSEG(QPut(0)), VARPTR(QPut(0))
DQBfPut 5, 97, 1, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 0, 111, 15, VARSEG(Buttons(0, 34 + (I * 2))), VARPTR(Buttons(0, 34 + (I * 2)))
DQBfPut 5, 98, 18, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 5, 96, 16, 111, 31, VARSEG(Buttons(0, 35 + (I * 2))), VARPTR(Buttons(0, 35 + (I * 2)))
NEXT

' Getting arrow keys
FOR I = 0 TO 7
DQBget 1, 192 + (I * 8), 80, 199 + (I * 8), 87, VARSEG(Arrows(0, I)), VARPTR(Arrows(0, I))
NEXT

' Load up last time
LoadMap CHR$(DA(3) + 65)
C = DA(3) * 2 + 4
X = DA(C)
Y = DA(C + 1)
LoadFromMap X, Y
LoadBIT
LoadSAV
DQBclearLayer 0: LoadTIL
LoadMusic CHR$(Header71(8))

END SUB

SUB LoadMap (Letter$)

DA(3) = ASC(Letter$) - 65
FOR I = 0 TO 4
LoadBSV I + 6, "MAPS\" + Letter$ + LTRIM$(STR$(I)) + ".MAP"
NEXT

END SUB

SUB LoadMusic (File$)

IF MasterSound <> 1 THEN EXIT SUB
IF ASC(File$) < 48 THEN EXIT SUB
File$ = "MUSIC\" + File$ + ".CXE"

'       Reset channels
FOR I = 1 TO 32: DQBstopVoice I: NEXT
FOR I = 13 TO 28
DQBstopVoice I
DQBsetVoiceVol I, 63
NEXT

'       Clear Music layers
FOR I = 14 TO 16
DQBclearLayer I
NEXT

'       Check for valid file
I = FREEFILE
OPEN File$ FOR BINARY AS #I
IF LOF(I) = 0 THEN
  CLOSE #I
  KILL File$
  IErrorEND "Music file not found: " + File$
END IF
F$ = SPACE$(8)
GET #I, , F$
IF F$ <> "CCMusic" THEN CLOSE #I: IErrorEND "Invalid file: " + File$

'       Sounds
F$ = SPACE$(12)
FOR A = 0 TO 15
GET #I, , F$
BB$ = ""
FOR C = 1 TO 12
L = ASC(MID$(F$, C, 1))
IF L > 32 AND L < 126 THEN BB$ = BB$ + MID$(F$, C, 1)
NEXT
IF BB$ <> "" THEN
IF DQBloadSound(A + 22, "MUSIC\" + BB$) THEN CLOSE #I: IErrorEND "Sound file missing: " + BB$ + " in music file: " + File$
END IF
NEXT

'       Grab the rest of the DATA
L = 14
F$ = SPACE$(320)
DEF SEG = VARSEG(F$)
DO
GET #I, , F$
FOR X = 0 TO 319
DQBpset L, X, Y, PEEK(SADD(F$) + X)
NEXT
Y = Y + 1: IF Y = 200 THEN Y = 0: L = L + 1: IF L = 17 THEN EXIT DO
LOOP UNTIL EOF(I)
CLOSE #I

'       Internal music playing variables get reseted as well
MusicPlaying = 1
MVwait& = 0
MVptr& = 0
MVLoop = 0

END SUB

SUB LoadSAV

LoadBSV 5, "SAVEDATA.SAV"
FOR Y = 0 TO 3
FOR X = 0 TO 17
Demos(X, Y) = DQBpoint(5, X + 302, Y)
NEXT
NEXT

END SUB

SUB LoadTIL

TIL$ = CHR$(Header71(6)) + CHR$(Header71(7))
LoadBSV 12, "TILES\" + TIL$ + ".TIL"
FOR I = 0 TO 63
PALpcw I + 128, DQBpoint(12, I, 197), DQBpoint(12, I, 198), DQBpoint(12, I, 199)
NEXT
PALreset

GrabTiles

END SUB

SUB MainLoad.Disp

' Drawing GRID of the MAP
Border
DQBboxf B0, 16, 160, 167, 192, 0

' Current label
C = DA(3) * 2 + 4
X = DA(C) * 18
Y = DA(C + 1) * 2 + 160
C = 0
FOR Y1 = Y TO Y + 1
FOR X1 = X TO X + 17
P = DQBpoint(8, X1, Y1)
IF P > 31 THEN A$ = A$ + CHR$(P)
C = C + 1
NEXT
NEXT
PrintS A$, 20, 175, 225, 0

' Editable loaded label
PrintS Desc$, 20, 184, 6, 4
DQBboxf B0, 177, 184, 301, 195, 0
PrintS "MASTER SAVE AND LOAD:", 111, 20, 22, 20
DQBget 1, 0, 152, 15, 167, VARSEG(EPut(0)), VARPTR(EPut(0))
FOR X = 0 TO 112 STEP 16
 FOR Y = 0 TO 112 STEP 16
  DQBfPut B0, X + 32, Y + 32, VARSEG(EPut(0)), VARPTR(EPut(0))
 NEXT
NEXT
FOR X = 0 TO 2
 DQBbox B0, 31 - X, 31 - X, 160 + X, 160 + X, 6 - X
 DQBbox B0, 175 - X, 31 - X, 274 + X, 82 + X, 6 - X
 DQBbox B0, 179 - X, 90 - X, 270 + X, 115 + X, 6 - X
 DQBbox B0, 168 - X, 128 - X, 292 + X, 169 + X, 6 - X
 DQBbox B0, 177 - X, 184 - X, 301 + X, 195 + X, 6 - X
NEXT

' Drawing Zone map to the grid
IF DA(3) < 4 THEN
 FOR Y = 2 TO 17
  FOR X = 2 TO 17
   C = DQBpoint(5, DA(3) * 20 + X, Y + 100)
   IF C THEN DQBfPut B0, X * 8 + 16, Y * 8 + 16, VARSEG(AGets(0, C)), VARPTR(AGets(0, C))
  NEXT
 NEXT
END IF

' Draw extras
SELECT CASE DA(3)
 CASE 0: FOR I = 1 TO 4: PrintS STR$(I), I * 16 + 32, 68, 23, 16: NEXT
 CASE 4
   DQBboxf B0, 32, 32, 159, 159, 21
   FOR X = 32 TO 128 STEP 32
   FOR Y = 32 TO 128 STEP 32
    DQBbox B0, X, Y, X + 31, Y + 31, 22
   NEXT
   NEXT
    FOR Y = 0 TO 7
    DQBbox B0, 88, Y * 8 + 96, 95, Y * 8 + 103, 22
    NEXT
END SELECT

' Draw flashing box
IF (FrameTile AND 1) THEN
 C = DA(3) * 2 + 4
 X = DA(C)
 Y = DA(C + 1)
 X1 = DQBpoint(6, X * 18, Y * 2 + 160) * 8 + 32
 Y1 = DQBpoint(6, X * 18 + 1, Y * 2 + 160) * 8 + 32
 WX = DQBpoint(6, X * 18 + 2, Y * 2 + 160) * 8
 WY = DQBpoint(6, X * 18 + 3, Y * 2 + 160) * 8
 IF WX > 0 OR WY > 0 THEN DQBboxf B0, X1, Y1, X1 + WX - 1, Y1 + WY - 1, 225
END IF

' Zones
A1$ = "DarkDread City"
A2$ = "Mottola Forest"
A3$ = "Underworld Berg"
A4$ = "Gould's Cavern"
A5$ = "Clinton's Colony"

' Print selected map
DQBboxf B0, 176, 32, 273, 81, 8
C = DA(14) * 10
DQBboxf B0, 176, 32 + C, 273, 41 + C, 226
DQBbox B0, 176, 32 + C, 273, 41 + C, 223
PrintS A1$, 188, 33, 6, 4
PrintS A2$, 188, 43, 6, 4
PrintS A3$, 188, 53, 6, 4
PrintS A4$, 188, 63, 6, 4
PrintS A5$, 188, 73, 6, 4

' Print loaded map
SELECT CASE DA(3)
 CASE 0: PrintS A1$, 45, 165, 214, 219
 CASE 1: PrintS A2$, 45, 165, 214, 219
 CASE 2: PrintS A3$, 45, 165, 214, 219
 CASE 3: PrintS A4$, 45, 165, 214, 219
 CASE 4: PrintS A5$, 45, 165, 214, 219
END SELECT

' Print other things
PrintS "Load Everything:", 188, 95, 55, 50
PrintS "Load Room DATA:", 172, 130, 55, 50
PrintS "Save Everything:", 181, 186, 55, 50
PrintS "--BackG:", 172, 140, 55, 50
PrintS "--Tiles:", 172, 150, 55, 50
PrintS "--Music:", 172, 160, 55, 50
PrintS Zero$(DA(61), 2), 216, 140, 6, 4
PrintS Zero$(DA(62), 2), 216, 150, 6, 4
PrintS MID$(MusicNames, DA(63) + 1, 1), 216, 160, 6, 4

' Arrows
FOR I = 0 TO 20 STEP 10
 DQBfPut B0, 240, 140 + I, VARSEG(Arrows(0, 0)), VARPTR(Arrows(0, 0))
 DQBfPut B0, 248, 140 + I, VARSEG(Arrows(0, 4)), VARPTR(Arrows(0, 4))
NEXT
IF Area = Active THEN
 SELECT CASE Area
  CASE 6: DQBfPut B0, 240, 140, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 7: DQBfPut B0, 248, 140, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 9: DQBfPut B0, 240, 150, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 10: DQBfPut B0, 248, 150, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 12: DQBfPut B0, 240, 160, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 13: DQBfPut B0, 248, 160, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
 END SELECT
END IF

' Buttons
DQBget 1, 192, 16, 223, 23, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBfPut B0, 210, 106, VARSEG(QPut(0)), VARPTR(QPut(0))
FOR I = 0 TO 30 STEP 10
DQBfPut B0, 259, 130 + I, VARSEG(QPut(0)), VARPTR(QPut(0))
NEXT
DQBget 1, 192, 72, 223, 79, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBfPut B0, 268, 186, VARSEG(QPut(0)), VARPTR(QPut(0))

' Pressed buttons
IF Active = Area THEN
 DQBget 1, 224, 16, 255, 23, VARSEG(QPut(0)), VARPTR(QPut(0))
 SELECT CASE Area
  CASE 3: DQBfPut B0, 210, 106, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 4: DQBfPut B0, 259, 130, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 5: DQBget 1, 224, 72, 255, 79, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBfPut B0, 268, 186, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 8: DQBfPut B0, 259, 140, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 11: DQBfPut B0, 259, 150, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 14: DQBfPut B0, 259, 160, VARSEG(QPut(0)), VARPTR(QPut(0))
 END SELECT
END IF

' Bars attached
DQBbox B0, 208, 84, 242, 88, 4
DQBbox B0, 209, 83, 241, 89, 5
DQBboxf B0, 210, 82, 240, 90, 6
DQBbox B0, 162, 48, 173, 64, 4
DQBbox B0, 161, 49, 174, 63, 5
DQBboxf B0, 160, 50, 175, 62, 6
DQBbox B0, 162, 129, 166, 137, 4
DQBbox B0, 161, 130, 167, 136, 5
DQBboxf B0, 160, 131, 168, 135, 6

END SUB

SUB MainLoad.Inp

' Description input
IF LEN(CH$) THEN
 C = ASC(CH$)
 P = LEN(Desc$)
 IF P AND C = 8 THEN Desc$ = LEFT$(Desc$, P - 1)
 IF C > 31 AND P < 24 THEN Desc$ = Desc$ + CH$
END IF

' Areas
IF MX > 31 AND MY > 31 AND MX < 160 AND MY < 160 THEN Area = 1
IF MX > 175 AND MX < 274 AND MY > 31 AND MY < 82 THEN Area = 2
IF MX >= 210 AND MX <= 241 AND MY >= 106 AND MY <= 113 THEN Area = 3
IF MX >= 259 AND MX <= 290 AND MY >= 130 AND MY <= 137 THEN Area = 4
IF MX >= 268 AND MX <= 299 AND MY >= 186 AND MY <= 193 THEN Area = 5
 IF MX >= 240 AND MX <= 247 THEN
  SELECT CASE MY
   CASE 140 TO 147: Area = 6
   CASE 150 TO 157: Area = 9
   CASE 160 TO 167: Area = 12
  END SELECT
 END IF
 IF MX >= 248 AND MX <= 255 THEN
  SELECT CASE MY
   CASE 140 TO 147: Area = 7
   CASE 150 TO 157: Area = 10
   CASE 160 TO 167: Area = 13
  END SELECT
 END IF
 IF MX >= 259 AND MX <= 290 THEN
  SELECT CASE MY
   CASE 140 TO 147: Area = 8
   CASE 150 TO 157: Area = 11
   CASE 160 TO 167: Area = 14
  END SELECT
 END IF

' Mouse click
IF MLB1 = 1 AND Area = 1 THEN
 C = DA(3) * 2 + 4
 X1 = DA(C)
 Y1 = DA(C + 1)
 DA(C) = (MX - 32) \ 8
 DA(C + 1) = (MY - 32) \ 8
  IF DQBpoint(6, DA(C) * 18 + 2, DA(C + 1) * 2 + 160) = 0 THEN
   DA(C) = X1
   DA(C + 1) = Y1
  END IF
END IF

' Zone
IF MLB1 AND Area = 2 THEN DA(14) = (MY - 32) \ 10

' Load and save
IF MLB1 = 1 THEN Active = Area
IF Active = Area AND MLB1 = -1 THEN
 SELECT CASE Area
 CASE 3: LoadMap CHR$(DA(14) + 65)
 CASE 5: SaveEverything
 CASE 8:  Header71(4) = ASC(LEFT$(Zero$(DA(61), 2), 1))
          Header71(5) = ASC(RIGHT$(Zero$(DA(61), 2), 1))
          LoadBIT
          CalcTrans
 CASE 11:
          Header71(6) = ASC(LEFT$(Zero$(DA(62), 2), 1))
          Header71(7) = ASC(RIGHT$(Zero$(DA(62), 2), 1))
          LoadTIL
          CalcTrans
 CASE 14: Header71(8) = ASC(MID$(MusicNames, DA(63) + 1, 1))
          LoadMusic CHR$(Header71(8))
 END SELECT
 IF Area = 3 OR Area = 4 THEN
      C = DA(3) * 2 + 4
      X = DA(C)
      Y = DA(C + 1)
      LoadSAV
      LoadFromMap X, Y
      DA(61) = VAL(CHR$(Header71(4)) + CHR$(Header71(5)))
      DA(62) = VAL(CHR$(Header71(6)) + CHR$(Header71(7)))
      DA(63) = INSTR(MusicNames, CHR$(Header71(8))) - 1
      LoadBIT
      LoadTIL
      LoadMusic CHR$(Header71(8))
      CalcTrans
  END IF
END IF

' Choosing file names
IF MLB2 = 1 AND Active = Area THEN
  SELECT CASE Area
   CASE 6: DA(61) = (DA(61) + 49) MOD 50
   CASE 7: DA(61) = (DA(61) + 1) MOD 50
   CASE 9: DA(62) = (DA(62) + 49) MOD 50
   CASE 10: DA(62) = (DA(62) + 1) MOD 50
   CASE 12: DA(63) = (DA(63) + 35) MOD 36
   CASE 13: DA(63) = (DA(63) + 1) MOD 36
  END SELECT
 END IF

END SUB

REM $DYNAMIC
SUB PALfadeBlack (Level, ColA, ColB)

FOR I = ColA TO ColB
 PALpcr I, R, G, B
 R = Interpolate(R, 0, Level, 63)
 G = Interpolate(G, 0, Level, 63)
 B = Interpolate(B, 0, Level, 63)
 PALscw I, R, G, B
NEXT

END SUB

SUB PALfadeIn (ColA, ColB)

FOR I = ColA TO ColB
 IF BUFPAL(I, 0) > THEPAL(I, 0) THEN BUFPAL(I, 0) = BUFPAL(I, 0) - 1
 IF BUFPAL(I, 1) > THEPAL(I, 1) THEN BUFPAL(I, 1) = BUFPAL(I, 1) - 1
 IF BUFPAL(I, 2) > THEPAL(I, 2) THEN BUFPAL(I, 2) = BUFPAL(I, 2) - 1
 IF BUFPAL(I, 0) < THEPAL(I, 0) THEN BUFPAL(I, 0) = BUFPAL(I, 0) + 1
 IF BUFPAL(I, 1) < THEPAL(I, 1) THEN BUFPAL(I, 1) = BUFPAL(I, 1) + 1
 IF BUFPAL(I, 2) < THEPAL(I, 2) THEN BUFPAL(I, 2) = BUFPAL(I, 2) + 1
NEXT

END SUB

SUB PALfadeOut (ColA, ColB, Red, Green, Blue)

FOR I = ColA TO ColB
 IF BUFPAL(I, 0) > Red THEN BUFPAL(I, 0) = BUFPAL(I, 0) - 1
 IF BUFPAL(I, 1) > Green THEN BUFPAL(I, 1) = BUFPAL(I, 1) - 1
 IF BUFPAL(I, 2) > Blue THEN BUFPAL(I, 2) = BUFPAL(I, 2) - 1
 IF BUFPAL(I, 0) < Red THEN BUFPAL(I, 0) = BUFPAL(I, 0) + 1
 IF BUFPAL(I, 1) < Green THEN BUFPAL(I, 1) = BUFPAL(I, 1) + 1
 IF BUFPAL(I, 2) < Blue THEN BUFPAL(I, 2) = BUFPAL(I, 2) + 1
NEXT

END SUB

SUB PALoff

OUT &H3C8, 0
FOR I = 0 TO 255
BUFPAL(I, 0) = 0
BUFPAL(I, 1) = 0
BUFPAL(I, 2) = 0
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, 0
NEXT

END SUB

SUB PALpcr (I, R, G, B)

R = THEPAL(I, 0)
G = THEPAL(I, 1)
B = THEPAL(I, 2)

END SUB

SUB PALpcw (I, R, G, B)

IF R > 63 THEN R = 63
IF G > 63 THEN G = 63
IF B > 63 THEN B = 63
IF R < 0 THEN R = 0
IF G < 0 THEN G = 0
IF B < 0 THEN B = 0
THEPAL(I, 0) = R
THEPAL(I, 1) = G
THEPAL(I, 2) = B

END SUB

SUB PALreset

FOR I = 0 TO 255
BUFPAL(I, 0) = THEPAL(I, 0)
BUFPAL(I, 1) = THEPAL(I, 1)
BUFPAL(I, 2) = THEPAL(I, 2)
NEXT

END SUB

SUB PALrotate (Col1, Col2, Dir)

IF Dir THEN

FOR A = Col1 TO Col2
Switch = A
R = BUFPAL(Switch, 0)
G = BUFPAL(Switch, 1)
B = BUFPAL(Switch, 2)
Switch = A - 1: IF Switch < Col1 THEN Switch = Col2
BUFPAL(Switch, 0) = R
BUFPAL(Switch, 1) = G
BUFPAL(Switch, 2) = B
NEXT

ELSE

FOR A = Col2 TO Col1 STEP -1
Switch = A
R = BUFPAL(Switch, 0)
G = BUFPAL(Switch, 1)
B = BUFPAL(Switch, 2)
Switch = A + 1: IF Switch > Col2 THEN Switch = Col1
BUFPAL(Switch, 0) = R
BUFPAL(Switch, 1) = G
BUFPAL(Switch, 2) = B
NEXT

END IF


END SUB

SUB PALscr (Index, Red, Green, Blue)

Red = BUFPAL(Index, 0)
Green = BUFPAL(Index, 1)
Blue = BUFPAL(Index, 2)

END SUB

SUB PALscw (I, R, G, B)

IF R > 63 THEN R = 63
IF G > 63 THEN G = 63
IF B > 63 THEN B = 63
IF R < 0 THEN R = 0
IF G < 0 THEN G = 0
IF B < 0 THEN B = 0
BUFPAL(I, 0) = R
BUFPAL(I, 1) = G
BUFPAL(I, 2) = B

END SUB

SUB PALupdate

OUT &H3C8, 0
FOR I = 0 TO 255
 OUT &H3C9, BUFPAL(I, 0)
 OUT &H3C9, BUFPAL(I, 1)
 OUT &H3C9, BUFPAL(I, 2)
NEXT

END SUB

