'    NOTE: You can only run this compiled with DQB 1.71
'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCMUSIC.BI'

Init
CreateBG

MainLoop:
 StartRef
 PCOPY 2, 1
   GetInput
   FieldDisplay
      SELECT CASE AWindow
       CASE 0: MenuSubMenu.Inp: IF AMenu = 0 THEN ParseInput
       CASE 1 TO 3, 13: ErrorPROMPT.Input: ErrorPROMPT.Disp
       CASE 4 TO 6: FilePROMPT.Input: FilePROMPT.Disp
       CASE 7: DescWindowInput: DescWindowDisp
       CASE 8 TO 10: File.Input: File.Disp
       CASE 11: UnloadInp: UnloadDisp
       CASE 12: PasteWindowInp: PasteWindowDisp
       CASE 14: MPWindowInp: MPWindowDisp
       CASE 15: SSegWindowInp: SSegWindowDisp
       CASE 16: TickSigInp: TickSigDisp
       CASE 17: RecInp: RecDisp
       CASE 18: RecNowInp: RecNowDisp
       CASE 19: StepRecInp: StepRecDisp
       CASE 20: QuantizeInp: QuantizeDisp
       CASE 21: NTransInp: NTransDisp
       CASE 22: MTransInp: MTransDisp
       CASE 23: TempoInp: TempoDisp
       CASE 24: PutNoteInp: PutNoteDisp
       CASE 25: ChanTVolInp: ChanTVolDisp
       CASE 26: StopCVInp: StopCVDisp
       CASE 27: PitchInp: PitchDisp
       CASE 28: MasterInp: MasterDisp
       CASE 29: SetChannelInp: SetChannelDisp
       CASE 30: LetLoopInp: LetLoopDisp
       CASE 31: GOTOInp: GOTODisp
       CASE 32: MeasureInp: MeasureDisp
      END SELECT
     ActionPlace
     IF LEN(CH$) AND AWindow = 0 AND AMenu = 0 AND ASubMenu = 0 THEN EventInput
     FPS.Display
     IF AMenu THEN MenuSubMenu.Disp
     ShowMouseCursor
     DQBwait 1
     IF CASPlaying THEN CAS.Play
   IF SHIFT AND CH$ = CHR$(27) THEN EndProg
 PCOPY 1, 0
GOTO MainLoop

REM $DYNAMIC
SUB CAS.Copy (Track, EveA, EveB)

' Get Copy length
EA = EveA
EB = EveB
IF EA > EB THEN SWAP EA, EB
CLen = (EB - EA) + 1
CTrack = Track
QQ = 0

' Copy selected data to
FOR I = EA TO (EA + (CLen - 1))
 JX1 = (I * 8&) MOD 320
 JY1 = I \ 40
 DQBget Track + 1, JX1, JY1, JX1 + 7, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 JX2 = (QQ * 8&) MOD 320
 JY2 = QQ \ 40
 DQBfPut 18, JX2, JY2, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 QQ = QQ + 1
NEXT

END SUB

SUB CAS.Delete (Track, EveA, EveB)

EA = EveA
EB = EveB
IF EA > EB THEN SWAP EA, EB
Undo = Track + 1
DQBcopyLayer Undo, 19
UndoTL = TrackLen(Track)
Modified = 1

' Scoot above DATA back
IF (TrackLen(Track) - EB) > 0 THEN
FOR I = (EB + 1) TO TrackLen(Track)
 JX1 = (I * 8&) MOD 320
 JY1 = (I \ 40)
 DQBget Track + 1, JX1, JY1, JX1 + 7, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 JX1 = ((EA + Q) * 8&) MOD 320
 JY1 = ((EA + Q) \ 40)
 DQBfPut Track + 1, JX1, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 Q = Q + 1
NEXT
END IF

' Wipe out removed data
Q = TrackLen(Track) - (EB - EA)
FOR I = Q TO TrackLen(Track)
 JX1 = (I * 8&) MOD 320
 JY1 = (I \ 40)
 DQBline Track + 1, JX1, JY1, JX1 + 7, JY1, 0
NEXT

' Reduce track length
IF TrackLen(Track) > 1 THEN
 TrackLen(Track) = TrackLen(Track) - ((EB - EA) + 1)
ELSE
 TrackLen(Track) = 0
END IF
IF Track = 0 THEN CAS.Sort.Track 0

END SUB

REM $STATIC
SUB CAS.Load (File$)

ClearProg

' Stop everything before loading
  CASPlaying = 0
  CAS.Stop

'Open File$
  IF DQBdir$(File$, 32) = "" THEN AWindow = 1: EXIT SUB
  OPEN File$ FOR BINARY AS #1

'Header
  A$ = SPACE$(8)
  GET #1, 1, A$
  IF A$ <> "CCTrack" THEN CLOSE #1: AWindow = 2: EXIT SUB

'Samples
 FOR I = 0 TO 15
  A$ = SPACE$(12)
  Samples(I) = A$
  GET #1, 9 + (I * 12), A$
  A$ = NoSpace$(A$)
  Samples(I) = A$
  IF LEN(A$) THEN IF DQBloadSound(I + 1, A$) THEN CLOSE #1: ErrorEND ""
 NEXT

'Description
  A$ = SPACE$(40)
  GET #1, 201, A$
  Description$ = LTRIM$(RTRIM$(A$))
  A$ = ""
   FOR I = 1 TO LEN(Description$)
    C$ = MID$(Description$, I, 1)
    IF ASC(C$) > 31 THEN A$ = A$ + C$
   NEXT
  Description$ = A$

'Tick Signature
  A$ = SPACE$(1)
  GET #1, 241, A$
  TickSig = ASC(A$) + 1

'Event length of each track
 FOR I = 0 TO 16
  A$ = SPACE$(2)
  GET #1, 242 + (I * 2), A$
  TrackLen(I) = CVI(A$)
 NEXT

'Grab all the events and stuff it into a file
 FOR I = 0 TO 16
  IF TrackLen(I) THEN
  FOR J = 0 TO TrackLen(I) - 1
   A$ = SPACE$(8)
   GET #1, , A$
    FOR X = 0 TO 7
     DQBpset I + 1, ((J * 8&) MOD 320) + X, J \ 40, ASC(MID$(A$, X + 1, 1))
    NEXT
  NEXT
 END IF
 NEXT

CLOSE #1

'Program name
Program$ = File$
ATrack = 1
CAS.Sort.Track 1

END SUB

SUB CAS.Paste (Track)

IF DummyInteger(6) THEN CT = 1
Numb1& = Str2Tim&(DummyString(0))

' Undo buffer
Undo = Track + 1
DQBcopyLayer Undo, 19
UndoTL = TrackLen(Track)
Modified = 1

' Track contents too large?
IF CLen + UndoTL > 8000 THEN AWindow = 13: EXIT SUB
ATrack = Track

' Simple, add data at the end, sort, and voila!
IF CT THEN PP = 1
FOR I = 0 TO CLen - 1
JX1 = (I * 8&) MOD 320
JY1 = I \ 40
 DQBget 18, JX1, JY1, JX1 + 7, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
JX1 = ((I + UndoTL) * 8&) MOD 320
JY1 = (I + UndoTL) \ 40
 DQBfPut Track + 1, JX1, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 Numb2& = DQBpoint(Track + 1, JX1, JY1)
 Numb2& = Numb2& + (DQBpoint(Track + 1, JX1 + 1, JY1) * 256&)
 Numb2& = Numb2& + (DQBpoint(Track + 1, JX1 + 2, JY1) * 65536)
 IF PP THEN PP = 0: Numb3& = Numb2&
 IF CT THEN Numb2& = (Numb2& - Numb3&) + Numb1&
 L& = (65535 * TickSig) + (TickSig - 1)
 IF Numb2& > L& THEN Numb2& = L&
 DQBpset Track + 1, JX1, JY1, Numb2& AND 255
 DQBpset Track + 1, JX1 + 1, JY1, (Numb2& \ 256) AND 255
 DQBpset Track + 1, JX1 + 2, JY1, (Numb2& \ 65536)
NEXT
TrackLen(Track) = UndoTL + CLen

' Sort the contents
CAS.Sort.Track Track

END SUB

SUB CAS.Play                    ' Play CAS file

FOR I = 0 TO 16
 IF I THEN
  RPoint = TrackPTR(I)
  IF TrackLen(I) AND RPoint < TrackLen(I) THEN
   IF Ticks& = TTE&(I, RPoint) THEN
    Byte4 = ByteGet4(I, RPoint)
    Byte5 = ByteGet5(I, RPoint)
    Byte6 = ByteGet6(I, RPoint)
    Byte7 = ByteGet7(I, RPoint)
    Byte8 = ByteGet8(I, RPoint)
    IF Byte4 THEN
     IF Byte4 < 5 THEN TrackPTR(I) = RPoint + 1: I = I - 1
      SELECT CASE Byte4
       CASE 1
        DQBplaySound 1 + (Byte5 AND 15), (Byte6 AND 15) + 1, Pitch(Byte7 AND 31), Byte8 AND 1
       CASE 2
        DQBsetVoiceVol 1 + (Byte5 AND 15), Byte6 AND 63
       CASE 3
        DQBstopVoice 1 + (Byte5 AND 15)
       CASE 4
        DQBsetFreq Byte5 + 1, (Byte6 + (Byte7 * 256&)) AND 32767
      END SELECT
     END IF
    END IF
   END IF
 ELSE
  RPoint = TrackPTR(0)
  IF TrackLen(0) AND RPoint < TrackLen(0) THEN
   IF Ticks& = TTE&(0, RPoint) THEN
    Byte4 = ByteGet4(0, RPoint)
    Byte5 = ByteGet5(0, RPoint)
    Byte6 = ByteGet6(0, RPoint)
    Byte7 = ByteGet7(0, RPoint)
    Byte8 = ByteGet8(0, RPoint)
    IF Byte4 THEN
     IF Byte4 < 15 THEN TrackPTR(0) = RPoint + 1: I = I - 1
      IF Byte4 > 9 AND AWindow = 18 THEN CASPlaying = 0: CAS.Stop
      SELECT CASE Byte4
       CASE 1: IF MLooped THEN CAS.Repeat ELSE CASPlaying = 0: CAS.Stop
       CASE 2: FOR II = 1 TO 16: DQBstopVoice II: NEXT
       CASE 3: CAS.Repeat: EXIT SUB
       CASE 4: LoopVal = (LoopVal + 1) AND 255
       CASE 5: LoopVal = (LoopVal - 1) AND 255
       CASE 6: LoopVal = Byte5
       CASE 7: LoopVal = (LoopVal + Byte5) AND 255
       CASE 8: LoopVal = (LoopVal - Byte5) AND 255
       CASE 9: FOR II = 1 TO 16: DQBsetVoiceVol II, Byte5: NEXT
       CASE 10: CAS.GOTO.Measure Byte6
       CASE 11: IF LoopVal < Byte5 THEN CAS.GOTO.Measure Byte6
       CASE 12: IF LoopVal > Byte5 THEN CAS.GOTO.Measure Byte6
       CASE 13: IF LoopVal = Byte5 THEN CAS.GOTO.Measure Byte6
      END SELECT
    END IF
   END IF
  END IF
 END IF
NEXT

IF CASPlaying THEN
 Ticks& = Ticks& + 1
 TimeE& = TimeE& + 1
END IF

END SUB

SUB CAS.Quantize (Trk, Choice, EveA, EveB)

SELECT CASE Choice
 CASE 0: L = TickSig
 CASE 1 TO 8: L = TickSig \ (2 ^ Choice)
END SELECT
IF L <= 1 THEN EXIT SUB
EvA = EveA
EvB = EveB

' Undo buffer
Undo = Trk + 1
DQBcopyLayer Undo, 19
UndoTL = TrackLen(Trk)
Modified = 1

IF EvA > EvB THEN SWAP EvA, EvB

FOR I = EvA TO EvB
 K& = TTE&(Trk, I)
 M = (K& MOD L)
  IF M <= (L \ 2) THEN
   K& = K& - M               ' Truncate
  ELSE
   K& = K& + (L - M)   ' Inc One
  END IF
 PutTime Trk, I, K&
NEXT

CAS.Sort.Track Trk

END SUB

SUB CAS.Repeat

LoopVal = 0
Ticks& = 0
FOR I = 0 TO 16
TrackPTR(I) = 0
NEXT

END SUB

SUB CAS.Save (File$)

File$ = UCASE$(LTRIM$(RTRIM$(File$)))

IF File$ = "(UNTITLED)" OR File$ = "" THEN AWindow = 2: EXIT SUB
OPEN File$ FOR BINARY AS #1

'Header
  A$ = "CCTrack"
  PUT #1, 1, A$

'Samples
 FOR I = 0 TO 15
  A$ = Samples(I)
  A$ = A$ + SPACE$(12 - LEN(A$))
  PUT #1, 9 + (I * 12), A$
 NEXT

'Description
  Description$ = Description$ + SPACE$(40 - LEN(Description$))
  PUT #1, 201, Description$
  Description$ = RTRIM$(Description$)

'Tick Signature
  A$ = CHR$(TickSig - 1)
  PUT #1, 241, A$

'Event length of each track
 FOR I = 0 TO 16
  A$ = MKI$(TrackLen(I))
  PUT #1, 242 + (I * 2), A$
 NEXT

'Grab all the events and stuff it into a file
 FOR I = 0 TO 16
 IF TrackLen(I) THEN
 FOR J = 0 TO TrackLen(I) - 1
  A$ = ""
   FOR X = 0 TO 7
    A$ = A$ + CHR$(DQBpoint(I + 1, ((J * 8&) MOD 320) + X, (J \ 40)))
   NEXT
  PUT #1, , A$
 NEXT
 END IF
 NEXT

CLOSE #1
Modified = 0
Program$ = File$

END SUB

SUB CAS.Stop

LoopVal = 0
Ticks& = 0
TimeE& = 0
TrackPTR(0) = 0
 FOR I = 1 TO 16
  TrackPTR(I) = 0
  IF DQBinUse(I) THEN DQBstopVoice I
  DQBsetVoiceVol I, 63
 NEXT

END SUB

SUB CAS.Trans.Note (Trk, Steps, EveA, EveB)

IF TrackLen(Trk) = 0 THEN EXIT SUB

EvA = EveA
EvB = EveB
IF EvA > EvB THEN SWAP EvA, EvB

' Undo buffer
Undo = Trk + 1
DQBcopyLayer Undo, 19
UndoTL = TrackLen(Trk)
Modified = 1

FOR I = EvA TO EvB
 C = ByteGet4(Trk, I)
 IF C = 1 THEN
   K = ByteGet7(Trk, I) + Steps
   IF K < -5 THEN K = K + 36
   IF K < 0 THEN K = K + 24
   IF K > 30 THEN K = K - 24
   PutByte7 Trk, I, K
 END IF
NEXT

END SUB

REM $DYNAMIC
SUB CleanDummies

REDIM DummyString(31) AS STRING   ' Used for input boxes
REDIM DummyInteger(31) AS INTEGER ' Used for input boxes

END SUB

REM $STATIC
SUB ClearProg

CASPlaying = 0: CAS.Stop
REDIM TrackLen(16) AS INTEGER
REDIM TrackPTR(16) AS INTEGER
REDIM TrackScr(16, 2) AS INTEGER
REDIM MeasCAS(255, 16) AS INTEGER
REDIM MeasRef(255) AS LONG
REDIM Samples(15) AS STRING

Program$ = "(UNTITLED)"
Description$ = Program$

 FOR I = 1 TO 16
 DQBclearLayer I
 IF LEN(OPath$) THEN IF DQBloadRawSound(I, OPath$ + "BLANK", 1, 320) THEN ErrorEND "Blank file missing"
 NEXT

DQBclearLayer 17
AWindow = 0
Modified = 0

END SUB

SUB CXE.Play (CXE$)

' Clean layers
CASPlaying = 0: CAS.Stop
FOR I = 20 TO 22
DQBclearLayer I
NEXT

' File check and handle
I = FREEFILE
IF DQBdir$(CXE$, 32) = "" THEN ErrorEND "File not found or bad format"
OPEN CXE$ FOR BINARY AS #1

' Valid file check
F$ = SPACE$(8)
GET #I, , F$
IF F$ <> "CCMusic" OR LOF(I) < 201 THEN AWindow = 2: CLOSE #1: EXIT SUB

' Grab samples
F$ = SPACE$(12)
FOR A = 0 TO 15
GET #I, , F$
BB$ = ""
FOR C = 1 TO 12
L = ASC(MID$(F$, C, 1))
IF L > 32 AND L < 126 THEN BB$ = BB$ + MID$(F$, C, 1)
NEXT
IF BB$ <> "" THEN
Samples(A) = BB$
IF DQBloadSound(A + 1, BB$) THEN CLOSE #I: ErrorEND ""
END IF
NEXT

' Grab all CXE data and put into memory
L = 20
F$ = SPACE$(320)
DEF SEG = VARSEG(F$)
DO
GET #I, , F$
FOR X = 0 TO 319
DQBpset L, X, Y, PEEK(SADD(F$) + X)
NEXT
Y = Y + 1: IF Y = 200 THEN Y = 0: L = L + 1: IF L = 23 THEN EXIT DO
LOOP UNTIL EOF(I)
CLOSE #I

' Delay routine
DelayWait:
CLS
' Print constants
COLOR 15, 0
LOCATE 2, 8: PRINT "---- Now playing "
LOCATE 4, 4: PRINT "ByteCode ="
LOCATE 5, 4: PRINT "LoopVal ="
LOCATE 6, 4: PRINT "Pointer ="
LOCATE 7, 4: PRINT "Count down delay ="
LOCATE 9, 16: PRINT "---- Channels in use: ----"
LOCATE 10, 8: PRINT "M"
LOCATE 12, 15: PRINT "---- Events triggered: ----"
FOR I = 0 TO 15
LOCATE 10, I * 2 + 10: PRINT LTRIM$(STR$(I + 1))
NEXT
' Print variables
COLOR 10
LOCATE 2, 25: PRINT CXE$
LOCATE 4, 14: PRINT BB1$ + BB2$ + BB3$ + BB4$ + BB5$
LOCATE 5, 13: PRINT MVloop
LOCATE 6, 13: PRINT MVptr&
LOCATE 7, 22: PRINT MVwait&
FOR I = 0 TO 15
LOCATE 11, I * 2 + 10: PRINT LTRIM$(STR$(-(DQBinUse(I + 1))))
NEXT
' Print footnotes
COLOR 11
LOCATE 23, 16: PRINT "Cyber Chick CXE Player v1.0";
LOCATE 25, 16: PRINT "<Press any key to continue>";

FOR I = 0 TO 16
X = NoteMeter(I) \ 4
 IF X THEN
  NoteMeter(I) = NoteMeter(I) - 1
  FOR Y = 1 TO X
   COLOR 10
   IF Y > 4 THEN COLOR 14
   IF Y > 6 THEN COLOR 12
   LOCATE 12 + Y, I * 2 + 8: PRINT ""
  NEXT
 END IF
NEXT

COLOR 9
FOR I = 0 TO 15
 LOCATE 4 + I, 45: PRINT I + 1; Samples(I)
NEXT

DQBwait 1
PCOPY 1, 0
IF LEN(INKEY$) THEN GOTO DoneCXE
IF MVwait& > 0 THEN MVwait& = MVwait& - 1: GOTO DelayWait

' CXE Player
DO
Byte1 = ByteCode(MVptr&): BB1$ = STR$(Byte1)
IF Byte1 = 0 THEN GOTO DoneCXE
BB2$ = "": BB3$ = "": BB4$ = "": BB5$ = ""

MVptr& = MVptr& + 1
IF Byte1 > 84 THEN Byte2 = ByteCode(MVptr&): MVptr& = MVptr& + 1: BB2$ = STR$(Byte2)
IF Byte1 > 122 THEN Byte3 = ByteCode(MVptr&): MVptr& = MVptr& + 1: BB3$ = STR$(Byte3)
IF Byte1 > 140 THEN Byte4 = ByteCode(MVptr&): MVptr& = MVptr& + 1: BB4$ = STR$(Byte4)
IF Byte1 > 190 THEN Byte5 = ByteCode(MVptr&): MVptr& = MVptr& + 1: BB5$ = STR$(Byte5)

' CXE interpreter
SELECT CASE Byte1
CASE 1 TO 32
 MVwait& = Byte1 - 1: GOTO DelayWait
CASE 33
 FOR I = 1 TO 16: DQBstopVoice I: NEXT: NoteMeter(0) = 32
CASE 34
 MVloop = 0: MVptr& = 0: NoteMeter(0) = 32
CASE 35
 MVloop = (MVloop + 1) AND 255: NoteMeter(0) = 32
CASE 36
 MVloop = (MVloop - 1) AND 255: NoteMeter(0) = 32
CASE 37 TO 52
 DQBplaySound Byte1 - 36, Byte1 - 36, 22050, 0: NoteMeter(Byte1 - 36) = 32
CASE 53 TO 68
 DQBplaySound Byte1 - 52, Byte1 - 52, 11025, 0: NoteMeter(Byte1 - 52) = 32
CASE 69 TO 84
 DQBplaySound Byte1 - 68, Byte1 - 68, 5513, 0: NoteMeter(Byte1 - 68) = 32
CASE 85
 MVloop = Byte2 AND 255: NoteMeter(0) = 32
CASE 86
 MVloop = (MVloop + Byte2) AND 255: NoteMeter(0) = 32
CASE 87
 MVloop = (MVloop - Byte2) AND 255: NoteMeter(0) = 32
CASE 88
 FOR I = 0 TO 15: DQBsetVoiceVol I + 1, Byte2 AND 63: NEXT: NoteMeter(0) = 32
CASE 89
 DQBstopVoice 1 + (Byte2 AND 15): NoteMeter(Byte2 + 1) = 32
CASE 90 TO 105
 DQBsetVoiceVol Byte1 - 89, Byte2 AND 63: NoteMeter(Byte1 - 89) = 32
CASE 106
 MVwait& = Byte2: GOTO DelayWait
CASE 107 TO 122
 DQBplaySound Byte1 - 106, Byte1 - 106, Pitch(Byte2 AND 31), Byte2 \ 32: NoteMeter(Byte1 - 106) = 32
CASE 123
 DQBplaySound 1 + (Byte2 AND 15), (Byte2 \ 16) + 1, Pitch(Byte3 AND 31), Byte3 \ 32: NoteMeter(1 + (Byte2 AND 15)) = 32
CASE 124
 MVwait& = (Byte3 * 256&) + Byte2: GOTO DelayWait
CASE 125 TO 140
 DQBsetFreq Byte1 - 124, Byte3 * 256& + Byte2: NoteMeter(Byte1 - 124) = 32
CASE 141
 MVwait& = (Byte4 * 65536) + (Byte3 * 256&) + Byte2: GOTO DelayWait: NoteMeter(0) = 32
CASE 142 TO 157
 IF MVloop < (Byte1 - 142) THEN MVptr& = (Byte4 * 65536) + (Byte3 * 256&) + Byte2: NoteMeter(0) = 32
CASE 158 TO 173
 IF MVloop > (Byte1 - 158) THEN MVptr& = (Byte4 * 65536) + (Byte3 * 256&) + Byte2: NoteMeter(0) = 32
CASE 174 TO 189
 IF MVloop = (Byte1 - 174) THEN MVptr& = (Byte4 * 65536) + (Byte3 * 256&) + Byte2: NoteMeter(0) = 32
CASE 190
 MVptr& = (Byte4 * 65536) + (Byte3 * 256&) + Byte2: NoteMeter(0) = 32
CASE 191
 IF MVloop < Byte2 THEN MVptr& = (Byte5 * 65536) + (Byte4 * 256&) + Byte3: NoteMeter(0) = 32
CASE 192
 IF MVloop > Byte2 THEN MVptr& = (Byte5 * 65536) + (Byte4 * 256&) + Byte3: NoteMeter(0) = 32
CASE 193
 IF MVloop = Byte2 THEN MVptr& = (Byte5 * 65536) + (Byte4 * 256&) + Byte3: NoteMeter(0) = 32
END SELECT
LOOP
DoneCXE:

FOR I = 1 TO 17
 DQBstopVoice I
 DQBsetVoiceVol I, 63
NEXT

END SUB

FUNCTION DirSub$ (FilSub, Poss)

JX = (Poss * 16&) MOD 320
JY = (Poss \ 20) + (FilSub * 100&)
A$ = ""
FOR I = 1 TO DQBpoint(23, JX, JY)
A$ = A$ + CHR$(DQBpoint(23, JX + I, JY))
NEXT
DirSub$ = UCASE$(A$)

END FUNCTION

REM $DYNAMIC
SUB ErrorEND (Text$)

DQBsetDrive LEFT$(OPath$, 1)
 Dummy = DQBchDir(OPath$)
 DQBremoveSB
 DQBclose
 SCREEN 0, , 0, 0
 CLS
 IF LEN(Text$) THEN PRINT Text$ ELSE PRINT DQBerror$
 Q& = SETMEM(40000)
END

END SUB

REM $STATIC
SUB FitEvent (Tim&, Trk, B4, B5, B6, B7, B8)

L = TrackLen(Trk)
IF L = 8000 THEN CH$ = CHR$(13): EXIT SUB
TrackLen(Trk) = TrackLen(Trk) + 1

' New event?
IF L = 0 THEN
 PutTime Trk, 0, Tim&
 PutByte4 Trk, 0, B4
 PutByte5 Trk, 0, B5
 PutByte6 Trk, 0, B6
 PutByte7 Trk, 0, B7
 PutByte8 Trk, 0, B8
 EXIT SUB
END IF

' Events already?
FOR I = 0 TO L - 1
 JX = (I * 8&) MOD 320
 JY = (I \ 40)
 FP& = DQBpoint(Trk + 1, JX, JY)
 FP& = FP& + (DQBpoint(Trk + 1, JX + 1, JY) * 256&)
 FP& = FP& + (DQBpoint(Trk + 1, JX + 2, JY) * 65536)
 Middle = I
 IF FP& >= Tim& THEN EXIT FOR
NEXT

IF Middle < L - 1 THEN
  FOR I = L - 1 TO Middle STEP -1
   JX = (I * 8&) MOD 320
   JY = (I \ 40)
   DQBget Trk + 1, JX, JY, JX + 7, JY, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
   DQBfPut Trk + 1, JX + 8, JY, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
  NEXT
 PutTime Trk, Middle, Tim&
 PutByte4 Trk, Middle, B4
 PutByte5 Trk, Middle, B5
 PutByte6 Trk, Middle, B6
 PutByte7 Trk, Middle, B7
 PutByte8 Trk, Middle, B8
ELSE                         ' Add at end
 PutTime Trk, L, Tim&
 PutByte4 Trk, L, B4
 PutByte5 Trk, L, B5
 PutByte6 Trk, L, B6
 PutByte7 Trk, L, B7
 PutByte8 Trk, L, B8
END IF

END SUB

SUB GetInput

' Grab input from keyboard
CH$ = INKEY$
  IF CTRL = -1 THEN CTRL = 0
  IF ALT = -1 THEN ALT = 0
  IF SHIFT = -1 THEN SHIFT = 0
 Scan = INP(96)
  IF SBAR = -1 THEN SBAR = 0
  IF Scan > 127 AND SBAR > 0 THEN SBAR = -1
  IF Scan = 57 THEN SBAR = SBAR - (SBAR < 2)
 DEF SEG = 65
  C = (PEEK(8) AND 1) OR (PEEK(134) AND 4)
  IF C THEN CTRL = CTRL - (CTRL < 2) ELSE IF CTRL THEN CTRL = -1
  C = (PEEK(8) AND 2) OR (PEEK(134) AND 8)
  IF C THEN ALT = ALT - (ALT < 2) ELSE IF ALT THEN ALT = -1
  C = (PEEK(7) AND 1) OR (PEEK(7) AND 2)
  IF PEEK(7) AND 128 THEN INS = 1 ELSE INS = 0
  IF C OR MLB1 = 2 THEN
   SHIFT = SHIFT - (SHIFT < 2)
    ELSE
   IF SHIFT THEN SHIFT = -1
  END IF

' Grab input from mouse
MX = DQBmouseX \ 4 + 1
MY = DQBmouseY \ 8 + 1
LB = DQBmouseLB

IF MLB1 = -1 THEN MLB1 = 0
IF MLB1 = 0 THEN SMouseHeld = 0
IF MDD THEN MDD = 0
IF LB THEN MLB1 = MLB1 - (MLB1 < 2) ELSE IF MLB1 THEN MLB1 = -1

' Double click delay
MDel2 = MDel2 + (MDel2 > 0)
IF MLB1 = 1 THEN
IF MDel2 THEN MDD = 1
MDel2 = 24
END IF

' Delay-holding for mouse input
IF LB THEN
 MDel = MDel + 1
 SELECT CASE MDel
  CASE 1: MLB2 = 1
  CASE 40: MLB2 = 1
  CASE 44: MLB2 = 1: MDel = 40
  CASE ELSE: MLB2 = 0
 END SELECT
ELSE
 MLB2 = 0
 MDel = 0
END IF

END SUB

SUB GrabFiles (Mask$)

DQBclearLayer 23
DummyString(0) = UCASE$(DQBdrive$ + ":\" + DQBpath$)

' Do we have a file?
A$ = UCASE$(LEFT$(DQBdir$(Mask$, 32), 12))
DummyString(17) = A$
C = LEN(A$)
IF C THEN
  DQBpset 23, 0, 0, C
    FOR I = 1 TO C
    DQBpset 23, I, 0, ASC(MID$(A$, I, 1))
    NEXT
   DummyInteger(1) = 1
 ELSE
   DummyInteger(1) = 0
END IF

' Grab the rest of the files.
DO
 A$ = UCASE$(LEFT$(DQBdir$("", 0), 12))
 C = LEN(A$)
 IF C = 0 THEN EXIT DO
 X = (DummyInteger(1) * 16&) MOD 320
 Y = (DummyInteger(1) \ 20)
 DQBpset 23, X, Y, C
   FOR I = 1 TO C
    DQBpset 23, X + I, Y, ASC(MID$(A$, I, 1))
   NEXT
 DummyInteger(1) = DummyInteger(1) + 1
 IF DummyInteger(1) = 1997 THEN EXIT DO
LOOP

' Do we have a sub directory?
A$ = UCASE$(LEFT$(DQBdir$("*.*", 16), 15))
C = LEN(A$)
IF C THEN
  DQBpset 23, 0, 100, C
   FOR I = 1 TO C
   DQBpset 23, I, 100, ASC(MID$(A$, I, 1))
   NEXT
   DummyInteger(8) = 1
 ELSE
   DummyInteger(8) = 0
END IF

' Grab the rest of the sub directories.
DO
 A$ = UCASE$(LEFT$(DQBdir$("", 16), 15))
 C = LEN(A$)
 IF C = 0 THEN EXIT DO
 X = (DummyInteger(8) * 16&) MOD 320
 Y = ((DummyInteger(8) \ 20)) + 100
 DQBpset 23, X, Y, C
   FOR I = 1 TO C
    DQBpset 23, X + I, Y, ASC(MID$(A$, I, 1))
   NEXT
 DummyInteger(8) = DummyInteger(8) + 1
 IF DummyInteger(8) = 1970 THEN EXIT DO
LOOP

' Grab all 26 possible drives just for the sake of it
FOR I = 1 TO 26
 IF I > DQBnumDrives% THEN EXIT FOR
 A$ = "[ " + CHR$(64 + I) + ":\ ]"
 X = (DummyInteger(8) * 16&) MOD 320
 Y = ((DummyInteger(8) \ 20)) + 100
 DQBpset 23, X, Y, 7
   FOR II = 1 TO 7
    DQBpset 23, X + II, Y, ASC(MID$(A$, II, 1))
   NEXT
 DummyInteger(8) = DummyInteger(8) + 1
 IF DummyInteger(8) = 1997 THEN EXIT FOR
NEXT

' Quicksort our files and directories

FOR YYY = 0 TO 1

IF YYY THEN C = DummyInteger(8) ELSE C = DummyInteger(1)
I = 0
J = 0
SP = 0
REDIM SL(-1 TO 63) AS INTEGER
REDIM SR(-1 TO 63) AS INTEGER
L = 0
R = 0

IF C > 1 THEN
 SL(0) = 0
 SR(0) = C - 1
BackAgain2:
 L = SL(SP)
 R = SR(SP)
 SP = SP - 1
 IF L >= R THEN
  IF SP >= 0 THEN GOTO BackAgain2 ELSE GOTO Finished2
 END IF
 IF I >= C THEN GOTO Finished2
 I = L
 J = R + 1
 A$ = DirSub$(YYY, L)
ScanLeft2:
 J = J - 1: IF DirSub$(YYY, J) > A$ THEN GOTO ScanLeft2
ScanRight2:
 I = I + 1: IF (DirSub$(YYY, I) < A$) AND (I < R) THEN GOTO ScanRight2
IF I < J THEN
 JX1 = (I * 16&) MOD 320: JY1 = (I \ 20) + (YYY * 100)
 JX2 = (J * 16&) MOD 320: JY2 = (J \ 20) + (YYY * 100)
  DQBget 23, JX1, JY1, JX1 + 15, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
  DQBget 23, JX2, JY2, JX2 + 15, JY2, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
  DQBfPut 23, JX1, JY1, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
  DQBfPut 23, JX2, JY2, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 GOTO ScanLeft2
END IF
JX1 = (L * 16&) MOD 320: JY1 = (L \ 20) + (YYY * 100)
JX2 = (J * 16&) MOD 320: JY2 = (J \ 20) + (YYY * 100)
 DQBget 23, JX1, JY1, JX1 + 15, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 DQBget 23, JX2, JY2, JX2 + 15, JY2, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
 DQBfPut 23, JX1, JY1, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
 DQBfPut 23, JX2, JY2, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
SP = SP + 1: SL(SP) = J + 1: SR(SP) = R
SP = SP + 1: SR(SP) = J - 1: SL(SP) = L
GOTO BackAgain2
END IF
Finished2:

NEXT YYY

END SUB

SUB Init

' Sound settings
Q& = SETMEM(-40000)
IF DQBinit(23, 17, 0) THEN ErrorEND ""
OPath$ = DQBdrive$ + ":\" + DQBpath$ + "\"

' Open sound config
OPEN "SOUND.INI" FOR INPUT AS #1
IF LOF(1) = 0 THEN CLOSE #1: ErrorEND "Run SETUP for sound"
INPUT #1, I   ' On/Off
INPUT #1, R   ' BaseAddr
INPUT #1, G   ' IRQ
INPUT #1, B   ' DMA
CLOSE #1

' Initiate sound
IF I THEN
 IF DQBinstallSB(-1, 32, 22050, R, G, B) THEN ErrorEND ""
ELSE
 ErrorEND "Turn the sound on in SETUP"
END IF

' Assign default variables
Program$ = "(UNTITLED)"
Description$ = Program$
TickSig = 256
ATrack = 1

' Make pitch table
G! = 31183
FOR P = 30 TO 0 STEP -1
Pitch(P) = CINT(G!)
G! = G! * .943875
NEXT

' Turn off insert
DEF SEG = 65
C = PEEK(7)
IF C AND 128 THEN POKE 7, C - 128

' Play CXE files instantly
A$ = COMMAND$
IF A$ <> "" THEN
  IF DQBchDir("MUSIC") THEN ErrorEND ""
     IF DQBdir$(A$, 32) = "" THEN
     ErrorEND "Command line options:" + CHR$(13) + " CCMUSICE [CXE File]" + CHR$(13) + " CCMUSICE [CAS File]" + CHR$(13) + " Note: This will switch to the sub directory 'MUSIC\' before loading files"
     ELSE
     OPEN A$ FOR BINARY AS #1
     B$ = SPACE$(8)
     GET #1, , B$
     CLOSE #1
    IF B$ = "CCMusic" THEN SCREEN 0, , 1, 0: CXE.Play A$: ErrorEND ""
    IF B$ = "CCTrack" THEN CAS.Load A$
  END IF
END IF

END SUB

SUB InpNumbers (Text$, Cursor, Length, Min&, Max&)

Text$ = LTRIM$(RTRIM$(Text$))
Text$ = STRING$(Length - LEN(Text$), "0") + Text$
IF CH$ = CHR$(0) + CHR$(71) THEN Cursor = 0
IF CH$ = CHR$(0) + CHR$(79) THEN Cursor = Length
IF CH$ = CHR$(8) AND Cursor > 0 THEN
 Cursor = Cursor - 1
 MID$(Text$, Cursor + 1, 1) = "0"
END IF
IF CH$ = CHR$(0) + CHR$(83) AND Cursor < Length THEN
 MID$(Text$, Cursor + 1, 1) = "0"
END IF
IF CH$ = CHR$(0) + CHR$(75) THEN Cursor = Cursor + (Cursor > 0)
IF CH$ = CHR$(0) + CHR$(77) THEN Cursor = Cursor - (Cursor < Length)
SELECT CASE CH$
CASE "1" TO "9", "0"
 IF Cursor < Length THEN
  MID$(Text$, Cursor + 1, 1) = CH$
  Cursor = Cursor + 1
 END IF
END SELECT

IF VAL(Text$) < Min& THEN Text$ = LTRIM$(STR$(Min&))
IF VAL(Text$) > Max& THEN Text$ = LTRIM$(STR$(Max&))
Text$ = STRING$(Length - LEN(Text$), "0") + Text$ + " "

END SUB

SUB InpTime (Text$, Curs, X, Y)

' Correct string for '0' input
C = INSTR(Text$, ":")
L$ = LEFT$(Text$, C - 1)
R$ = RIGHT$(Text$, LEN(Text$) - C)
L$ = STRING$(5 - LEN(L$), "0") + L$
IF VAL(R$) > TickSig - 1 THEN R$ = LTRIM$(STR$(TickSig - 1))
R$ = STRING$(3 - LEN(R$), "0") + R$
Text$ = L$ + ":" + R$
P = Curs

' Mouse
IF MY = Y AND MLB1 = 1 THEN
IF MX >= X AND MX <= X + 8 THEN
Curs = MX - X
END IF
END IF

' Keypresses
SELECT CASE CH$
 CASE CHR$(8): Curs = Curs + (Curs > 0): M = 1
 CASE CHR$(0) + CHR$(71): Curs = 0
 CASE CHR$(0) + CHR$(75): Curs = Curs + (Curs > 0)
 CASE CHR$(0) + CHR$(77): Curs = Curs - (Curs < 8)
 CASE CHR$(0) + CHR$(79): Curs = 8
 CASE CHR$(0) + CHR$(83): M = 1
 CASE "0", "1" TO "9": MID$(Text$, Curs + 1, 1) = CH$: Curs = Curs - (Curs < 8)
END SELECT
IF Curs = 5 AND P < Curs THEN Curs = 6
IF Curs = 5 AND P > Curs THEN Curs = 4
IF VAL(LEFT$(Text$, 5)) > 65535 THEN MID$(Text$, 1, 5) = "65535"
IF M THEN MID$(Text$, Curs + 1, 1) = "0"

END SUB

SUB InputString (Text$, Cursor, Length)

' This is where the string gets messed with by
' Left/Right keys, Home+End keys
' Insert+Backspace+Delete

IF CH$ = CHR$(0) + CHR$(71) THEN Cursor = 0
IF CH$ = CHR$(0) + CHR$(79) THEN Cursor = LEN(RTRIM$(Text$))
IF CH$ = CHR$(8) AND Cursor > 0 THEN
 Cursor = Cursor - 1
 AAL$ = LEFT$(Text$, Cursor)
 AAR$ = RIGHT$(Text$, LEN(Text$) - Cursor - 1)
 Text$ = AAL$ + AAR$ + " "
END IF
IF CH$ = CHR$(0) + CHR$(83) AND Cursor < Length THEN
 AAL$ = LEFT$(Text$, Cursor)
 AAR$ = RIGHT$(Text$, LEN(Text$) - Cursor - 1)
 Text$ = AAL$ + AAR$ + " "
END IF
IF CH$ = CHR$(0) + CHR$(75) THEN Cursor = Cursor + (Cursor > 0)
IF CH$ = CHR$(0) + CHR$(77) THEN Cursor = Cursor - (Cursor < Length)
IF LEN(CH$) THEN
 IF ASC(CH$) > 31 AND Cursor < Length THEN
  IF INS THEN
   MID$(Text$, Cursor + 1, 1) = CH$
  ELSE
   IF RIGHT$(Text$, 1) = " " THEN
    AAL$ = LEFT$(Text$, Cursor)
    AAR$ = RIGHT$(Text$, LEN(Text$) - Cursor)
    Text$ = AAL$ + CH$ + AAR$
    Text$ = LEFT$(Text$, Length)
   END IF
  END IF
  Cursor = Cursor + 1
 END IF
END IF

END SUB

FUNCTION Interpolate (Number1, Number2, Value, MaxValue)

IF Number1 = Number2 THEN Interpolate = Number1: EXIT FUNCTION

IF Number1 < Number2 THEN
 Dist& = Number2 - Number1
 Interpolate = (Value * Dist& / MaxValue) + Number1
ELSE
 Dist& = Number1 - Number2
 Interpolate = Number1 - (Value * Dist& / MaxValue)
END IF

END FUNCTION

SUB MenuSubMenu.Disp

IF AMenu AND ASubMenu = 0 THEN
 PokeCol 1, 4, 15, 0
 PokeCol 1, 10, 15, 0
 PokeCol 1, 16, 15, 0
END IF

SELECT CASE ABS(AMenu)
CASE 2: InvertBox 0, 2, 0, 7
CASE 3: InvertBox 0, 8, 0, 13
CASE 4: InvertBox 0, 14, 0, 20
END SELECT

IF ASubMenu THEN

C = ATrack
IF C = 0 THEN C = 1
A$ = LTRIM$(STR$(C))
IF LEN(A$) = 1 THEN A$ = A$ + "."
A$ = A$ + ".."

IF ABS(AMenu) = 2 THEN
 MakeBoxF 3, 5, 17, 25, 32, 0, 0
 COLOR 7, 1
 LOCATE 2, 3: PRINT "Ŀ"
 LOCATE , 3: PRINT " New CAS           "
 LOCATE , 3: PRINT " Open CAS...       "
 LOCATE , 3: PRINT " Save              "
 LOCATE , 3: PRINT " Save As...        "
 LOCATE , 3: PRINT "Ĵ"
 LOCATE , 3: PRINT " Load Sample #" + A$ + " "
 LOCATE , 3: PRINT " Unload Samples... "
 LOCATE , 3: PRINT "Ĵ"
 LOCATE , 3: PRINT " DOS Shell         "
 LOCATE , 3: PRINT "Ĵ"
 LOCATE , 3: PRINT " Make CXE File     "
 LOCATE , 3: PRINT "Ĵ"
 LOCATE , 3: PRINT " Exit              "
 LOCATE , 3: PRINT ""
   PokeCol 3, 5, 15, 1: PokeCol 4, 5, 15, 1
   PokeCol 5, 5, 15, 1: PokeCol 6, 10, 15, 1
   PokeCol 8, 5, 15, 1: PokeCol 9, 5, 15, 1
   PokeCol 11, 5, 15, 1: PokeCol 13, 5, 15, 1: PokeCol 15, 6, 15, 1
  SELECT CASE ASubMenu
   CASE 1 TO 4: InvertBox 1 + ASubMenu, 3, 1 + ASubMenu, 21
   CASE 5: InvertBox 7, 3, 7, 21: CASE 6: InvertBox 8, 3, 8, 21
   CASE 7: InvertBox 10, 3, 10, 21: CASE 8: InvertBox 12, 3, 12, 21
   CASE 9: InvertBox 14, 3, 14, 21
  END SELECT
END IF

IF ABS(AMenu) = 3 THEN
 MakeBoxF 3, 11, 12, 36, 32, 0, 0
 COLOR 7, 1
 LOCATE 2, 9: PRINT "Ŀ"
 LOCATE , 9: PRINT " Undo    Ctrl+Backspace "
 LOCATE , 9: PRINT " Copy            Ctrl+C "
 LOCATE , 9: PRINT " Cut             Ctrl+X "
 LOCATE , 9: PRINT " Delete             Del "
 LOCATE , 9: PRINT " Paste...        Ctrl+V "
 LOCATE , 9: PRINT "Ĵ"
 LOCATE , 9: PRINT " Select All      Ctrl+A "
 LOCATE , 9: PRINT " Select Segment...      "
 LOCATE , 9: PRINT ""
   PokeCol 3, 11, 15, 1: PokeCol 4, 11, 15, 1
   PokeCol 5, 13, 15, 1: PokeCol 6, 11, 15, 1
   PokeCol 7, 11, 15, 1: PokeCol 9, 18, 15, 1
   PokeCol 10, 11, 15, 1
  SELECT CASE ASubMenu
   CASE 1 TO 5: InvertBox ASubMenu + 1, 9, ASubMenu + 1, 32
   CASE 6 TO 7: InvertBox ASubMenu + 2, 9, ASubMenu + 2, 32
  END SELECT
END IF

IF ABS(AMenu) = 4 THEN
 MakeBoxF 3, 17, 14, 44, 32, 0, 0
 COLOR 7, 1
 LOCATE 2, 15: PRINT "Ŀ"
 LOCATE , 15: PRINT " Description...        F2 "
 LOCATE , 15: PRINT " Auto Repeat [OFF]     F3 "
 LOCATE , 15: PRINT " Time Signature...     F4 "
 LOCATE , 15: PRINT " Play/Stop             F5 "
 LOCATE , 15: PRINT " Recording...          F6 "
 LOCATE , 15: PRINT " Step Recording...     F7 "
 LOCATE , 15: PRINT " Quantize...           F8 "
 LOCATE , 15: PRINT " Note Transpose...     F9 "
 LOCATE , 15: PRINT " Measure Transpose... F10 "
 LOCATE , 15: PRINT " Tempo Test...        F11 "
 LOCATE , 15: PRINT ""
  FOR I = 3 TO 11: PokeCol I, 17, 15, 1: NEXT
   PokeCol 12, 18, 15, 1
   IF MLooped THEN LOCATE 4, 29: PRINT "[ON] "
   IF ASubMenu > 0 THEN InvertBox ASubMenu + 1, 15, ASubMenu + 1, 40
END IF

END IF

END SUB

SUB MenuSubMenu.Inp

IF SMouseHeld THEN EXIT SUB

' Menu activate and deactivate by ALT key
IF AMenu >= 2 AND ASubMenu = 0 AND CH$ = CHR$(13) THEN CH$ = CHR$(0) + CHR$(80)
IF AMenu AND ALT = 1 THEN AMenu = -AMenu
IF AMenu = 0 AND ALT = 1 THEN AMenu = 1
IF AMenu < 0 AND ALT = -1 THEN
 IF ASubMenu THEN
  AMenu = 2: ASubMenu = 0
 ELSE
  AMenu = 0: ASubMenu = 0
 END IF
END IF
IF AMenu = 1 AND ALT = -1 THEN AMenu = 2

' Cancel
IF CH$ = CHR$(27) THEN AMenu = 0: ASubMenu = 0

' Short cuts
IF AMenu AND ASubMenu = 0 THEN
 SELECT CASE UCASE$(CH$)
  CASE CHR$(0) + CHR$(72): ASubMenu = 1: CH$ = ""
  CASE CHR$(0) + CHR$(80): ASubMenu = 1: CH$ = ""
  CASE "F", CHR$(0) + CHR$(33): AMenu = 2: ASubMenu = 1: CH$ = ""
  CASE "E", CHR$(0) + CHR$(18): AMenu = 3: ASubMenu = 1: CH$ = ""
  CASE "M", CHR$(0) + CHR$(50): AMenu = 4: ASubMenu = 1: CH$ = ""
 END SELECT
END IF

' Sub menu choices
IF AMenu AND ASubMenu <> 0 THEN
 SELECT CASE AMenu
  CASE 2: C = 9
  CASE 3: C = 7
  CASE 4: C = 10
 END SELECT
 SELECT CASE CH$
  CASE CHR$(0) + CHR$(72)
   IF ASubMenu > 0 THEN ASubMenu = ASubMenu - 1
   IF ASubMenu = 0 THEN ASubMenu = C
   IF ASubMenu = -1 THEN ASubMenu = 1
  CASE CHR$(0) + CHR$(80)
   IF ASubMenu = -1 THEN ASubMenu = 0
   IF ASubMenu = C THEN ASubMenu = 0
   IF ASubMenu < C THEN ASubMenu = ASubMenu + 1
 END SELECT
END IF

' File menu keys
IF ABS(AMenu) = 2 AND ASubMenu > 0 THEN
 SELECT CASE UCASE$(CH$)
  CASE CHR$(13): IF ASubMenu > 0 THEN Pex = ASubMenu
  CASE "N", CHR$(0) + CHR$(49): Pex = 1
  CASE "O", CHR$(0) + CHR$(24): Pex = 2
  CASE "S", CHR$(0) + CHR$(31): Pex = 3
  CASE "A", CHR$(0) + CHR$(30): Pex = 4
  CASE "L", CHR$(0) + CHR$(38): Pex = 5
  CASE "U", CHR$(0) + CHR$(22): Pex = 6
  CASE "D", CHR$(0) + CHR$(32): Pex = 7
  CASE "M", CHR$(0) + CHR$(50): Pex = 8
  CASE "X", CHR$(0) + CHR$(45): Pex = 9
 END SELECT
END IF

' Edit menu keys
IF ABS(AMenu) = 3 AND ASubMenu > 0 THEN
 SELECT CASE UCASE$(CH$)
  CASE CHR$(13): IF ASubMenu > 0 THEN Pex = ASubMenu
  CASE "U", CHR$(0) + CHR$(22), CHR$(127): Pex = 1
  CASE "C", CHR$(0) + CHR$(46), CHR$(3): Pex = 2
  CASE "T", CHR$(0) + CHR$(22), CHR$(24): Pex = 3
  CASE "D", CHR$(0) + CHR$(32), CHR$(0) + CHR$(83): Pex = 4
  CASE "P", CHR$(0) + CHR$(25), CHR$(22): Pex = 5
  CASE "A", CHR$(0) + CHR$(30), CHR$(1): Pex = 6
  CASE "S", CHR$(0) + CHR$(31), CHR$(19): Pex = 7
 END SELECT
END IF

' Music menu keys
IF ABS(AMenu) = 4 AND ASubMenu > 0 THEN
 SELECT CASE UCASE$(CH$)
  CASE CHR$(13): IF ASubMenu > 0 THEN Pex = ASubMenu
  CASE "D", CHR$(0) + CHR$(32), CHR$(0) + CHR$(60): Pex = 1
  CASE "A", CHR$(0) + CHR$(20), CHR$(0) + CHR$(61): Pex = 2
  CASE "T", CHR$(0) + CHR$(20), CHR$(0) + CHR$(62): Pex = 3
  CASE "P", CHR$(0) + CHR$(25), CHR$(0) + CHR$(63): Pex = 4
  CASE "R", CHR$(0) + CHR$(19), CHR$(0) + CHR$(64): Pex = 5
  CASE "S", CHR$(0) + CHR$(31), CHR$(0) + CHR$(65): Pex = 6
  CASE "Q", CHR$(0) + CHR$(16), CHR$(0) + CHR$(66): Pex = 7
  CASE "N", CHR$(0) + CHR$(49), CHR$(0) + CHR$(67): Pex = 8
  CASE "M", CHR$(0) + CHR$(50), CHR$(0) + CHR$(68): Pex = 9
  CASE "E", CHR$(0) + CHR$(18), CHR$(0) + CHR$(133): Pex = 10
 END SELECT
END IF

' Mouse held on menu buttons
IF MLB1 AND MY = 1 THEN
 SELECT CASE MX
  CASE 3 TO 8: Area = 2
  CASE 9 TO 14: Area = 3
  CASE 15 TO 21: Area = 4
  CASE ELSE: Area = 0
 END SELECT
 IF Area THEN
  IF MLB1 = -1 AND AMenu < 0 THEN AMenu = 0
  IF MLB1 >= 1 THEN ASubMenu = -1: AMenu = Area
  IF MLB1 = -1 THEN AMenu = Area: ASubMenu = 1: MLB1 = 0
 END IF
END IF

IF ((MX < 3) OR (MX > 21)) AND MLB1 = -1 THEN ASubMenu = -1
Area = 0

IF AMenu = 2 THEN
 IF MX >= 3 AND MX <= 23 THEN
  IF MY >= 2 AND MY <= 16 THEN
    Area = 1                     ' File menu box range
  END IF
 END IF
END IF
 
IF AMenu = 3 THEN
 IF MX >= 9 AND MX <= 34 THEN
  IF MY >= 2 AND MY <= 11 THEN
   Area = 2                     ' Edit menu box range
  END IF
 END IF
END IF

IF AMenu = 4 THEN
 IF MX >= 15 AND MX <= 42 THEN
  IF MY >= 2 AND MY <= 13 THEN
   Area = 3                     ' Music menu box range
  END IF
 END IF
END IF

IF Area = 0 AND MLB1 = 1 AND MY > 1 THEN AMenu = 0: ASubMenu = 0

' Mouse input for menu
IF MLB1 THEN
 IF Area = 0 THEN ASubMenu = -1
 IF Area = 1 THEN
  SELECT CASE MY
   CASE 3 TO 6: ASubMenu = MY - 2
   CASE 8 TO 9: ASubMenu = MY - 3
   CASE 11: ASubMenu = 7
   CASE 13: ASubMenu = 8
   CASE 15: ASubMenu = 9
   CASE ELSE: ASubMenu = -1
  END SELECT
 END IF
 IF Area = 2 THEN
  SELECT CASE MY
   CASE 3 TO 7: ASubMenu = MY - 2
   CASE 9 TO 10: ASubMenu = MY - 3
   CASE ELSE: ASubMenu = -1
  END SELECT
 END IF
  IF Area = 3 THEN
   SELECT CASE MY
    CASE 3 TO 12: ASubMenu = MY - 2
    CASE ELSE: ASubMenu = -1
   END SELECT
  END IF
     IF MLB1 = -1 THEN
      SELECT CASE ASubMenu
       CASE -1: AMenu = 0: ASubMenu = 0: MLB1 = 0
       CASE IS > 0: Pex = ASubMenu
      END SELECT
     END IF
END IF

' Left key
IF CH$ = CHR$(0) + CHR$(75) AND MLB1 = 0 AND ABS(AMenu) > 1 THEN
 IF AMenu = 2 THEN AMenu = 4 ELSE AMenu = AMenu - 1
 AMenu = ABS(AMenu)
 IF ASubMenu THEN ASubMenu = 1
END IF

' Right key
IF CH$ = CHR$(0) + CHR$(77) AND MLB1 = 0 AND ABS(AMenu) > 1 THEN
 IF AMenu = 4 THEN AMenu = 2 ELSE AMenu = AMenu + 1
 AMenu = ABS(AMenu)
 IF ASubMenu THEN ASubMenu = 1
END IF

' Reference message for each thingy
IF ABS(AMenu) = 2 THEN
 C = ATrack
 IF C = 0 THEN C = 1
 A$ = LTRIM$(STR$(C))
 SELECT CASE ASubMenu
  CASE 1: Ref$ = "Clears current CAS from memory"
  CASE 2: Ref$ = "Open an existing CAS file from disk"
  CASE 3: Ref$ = "Save changes in your CAS file to disk"
  CASE 4: Ref$ = "Save new CAS by specifying new name"
  CASE 5: Ref$ = "Load WAV file #" + A$ + " into memory for CAS"
  CASE 6: Ref$ = "Unload WAV files from memory for CAS"
  CASE 7: Ref$ = "Temporarily suspends CCME and invokes DOS Shell"
  CASE 8: Ref$ = "Convert CAS to CXE file instantly"
  CASE 9: Ref$ = "Exit CCME and return to OS"
 END SELECT
END IF

' Reference message for each thingy
IF ABS(AMenu) = 3 THEN
 SELECT CASE ASubMenu
  CASE 1: Ref$ = "Restores back previous change to music track"
  CASE 2: Ref$ = "Copies selected music track content into clipboard"
  CASE 3: Ref$ = "Deletes selected content and copies to clipboard"
  CASE 4: Ref$ = "Deletes selected content without copying to clipboard"
  CASE 5: Ref$ = "Inserts music track content from clipboard"
  CASE 6: Ref$ = "Selects and highlights everything in the music track"
  CASE 7: Ref$ = "Select a segment by specifying Point A and Point B"
 END SELECT
END IF

IF ABS(AMenu) = 4 THEN
 SELECT CASE ASubMenu
  CASE 1: Ref$ = "Describe your music with a title"
  CASE 2: Ref$ = "Auto repeat will override `Stop Music' event for your purposes"
  CASE 3: Ref$ = "Specify tick signature for your tempo variations"
  CASE 4: Ref$ = "Plays and stops CAS music instantly"
  CASE 5: Ref$ = "Playback music tracks and record a music track in realtime!"
  CASE 6: Ref$ = "Punch in notes sequentially from keyboard with precision!"
  CASE 7: Ref$ = "Round all your events to a given precision!"
  CASE 8: Ref$ = "Increment notation for transposing to a new chord"
  CASE 9: Ref$ = "Change the timing that is assigned to the highlighted events"
  CASE 10: Ref$ = "Estimate the tempo you need with this"
 END SELECT
END IF

' Action for FILE
IF ABS(AMenu) = 2 THEN
IF Pex THEN AMenu = 0: ASubMenu = 0
SELECT CASE Pex
  CASE 1
    Anything = 2
    IF Modified THEN AWindow = 4
  CASE 2
    AWindow = 8: CH$ = ""
    IF Modified THEN AWindow = 4: Anything = 4
  CASE 3: IF Program$ = "(UNTITLED)" THEN AWindow = 9 ELSE CAS.Save Program$
  CASE 4: AWindow = 9: CH$ = ""
  CASE 5: AWindow = 10: CH$ = "": IF ATrack = 0 THEN ATrack = 1
  CASE 6: AWindow = 11: CH$ = ""
  CASE 7
    SCREEN 0, , 0, 0
    IF CASPlaying THEN CASPlaying = 0: CAS.Stop
    CLS
    SHELL
    LOCATE 25, 1: PRINT "Press any key to continue";
    DO: LOOP UNTIL LEN(INKEY$)
    SCREEN 0, , 1, 0
  CASE 8
   Anything = 1
   IF Program$ = "(UNTITLED)" THEN AWindow = 9
  CASE 9
   Anything = 3
   IF Modified THEN AWindow = 4
END SELECT
END IF

IF ABS(AMenu) = 3 THEN
 SELECT CASE Pex
 CASE 1
    IF Undo THEN
      AMenu = 0: ASubMenu = 0
      DQBcopyLayer 19, Undo
      TrackLen(Undo - 1) = UndoTL
      Undo = 0
      CH$ = ""
    END IF
 CASE 2: IF TrackLen(ATrack) > 0 THEN CH$ = CHR$(3): AMenu = 0: ASubMenu = 0
 CASE 3
     IF TrackLen(ATrack) THEN
      CH$ = ""
      CAS.Copy ATrack, TrackScr(ATrack, 1), TrackScr(ATrack, 2)
      CAS.Delete ATrack, TrackScr(ATrack, 1), TrackScr(ATrack, 2)
      ScrollField ATrack, 0
      TrackScr(ATrack, 2) = TrackScr(ATrack, 1)
      AMenu = 0: ASubMenu = 0
     END IF
 CASE 4: CH$ = CHR$(0) + CHR$(83): AMenu = 0: ASubMenu = 0
 CASE 5: IF CLen THEN CH$ = CHR$(22): AMenu = 0: ASubMenu = 0
 CASE 6: CH$ = "": AMenu = 0: ASubMenu = 0
         TrackScr(ATrack, 0) = 0
         TrackScr(ATrack, 1) = 0
         TrackScr(ATrack, 2) = TrackLen(ATrack) - 1
 CASE 7: IF TrackLen(ATrack) THEN AWindow = 15: AMenu = 0: ASubMenu = 0
 END SELECT
END IF

IF ABS(AMenu) = 4 THEN
 IF Pex THEN
  AMenu = 0: ASubMenu = 0
  CH$ = CHR$(0) + CHR$(59 + Pex)
  IF Pex = 10 THEN CH$ = CHR$(0) + CHR$(133)
 END IF
END IF

END SUB

FUNCTION NoSpace$ (Text$)

FOR I = 1 TO LEN(Text$)
B = ASC(MID$(Text$, I, 1))
IF B > 32 AND B < 127 AND B$ <> "[" AND B$ <> "]" THEN A$ = A$ + CHR$(B)
NEXT
NoSpace$ = A$

END FUNCTION

SUB ParseInput

' Description
IF MDD THEN
IF MY = 2 THEN AWindow = 7: EXIT SUB
IF MY = 23 AND MX >= 36 AND MX <= 56 THEN AWindow = 16: EXIT SUB
END IF

' Field being clicked on
IF MLB1 = 1 AND MY >= 5 THEN
 IF MX >= 2 AND MX <= 41 AND MY <= 20 THEN AField = 0
 IF MX >= 46 AND MX <= 63 AND MY <= 8 - ((ATrack = 0) * 4) THEN AField = 1
 IF MX >= 67 AND MX <= 77 AND MY <= 21 THEN AField = 2
END IF

 'Dragging ring in music field
IF SMouseHeld THEN
 CH$ = ""
 C = MY - 6
 IF C < 0 THEN C = 0
 IF C > 13 THEN C = 13
 YY = Interpolate(16, TrackLen(ATrack), C, 13) - 1
 TrackScr(ATrack, 0) = 0
 TrackScr(ATrack, 1) = 0
 ScrollField ATrack, YY
 TrackScr(ATrack, 2) = TrackScr(ATrack, 1)
 EXIT SUB
END IF

 'Dragging in the music field
IF MLB1 > 0 AND MX >= 2 AND MY >= 4 AND MX <= 41 AND MY <= 21 THEN
  IF MLB1 = 1 THEN TrackScr(ATrack, 2) = TrackScr(ATrack, 1)
   IF AField = 0 AND MLB1 = 2 THEN
   IF MY = 4 THEN ScrollField ATrack, -1
   IF MY = 21 THEN ScrollField ATrack, 1
   IF MY > 4 AND MY < 21 THEN
    C = TrackScr(ATrack, 1) - TrackScr(ATrack, 0)
    K = (MY - 5) - C
    ScrollField ATrack, K
   END IF
  END IF
END IF

 'Scroll bar on
IF MX = 42 AND MY >= 5 AND MY <= 20 AND TrackLen(ATrack) > 16 THEN
 C = Interpolate(6, 19, TrackScr(ATrack, 0), (TrackLen(ATrack) - 16))
 IF MLB2 AND MY = 5 THEN ScrollField ATrack, -1
 IF MLB2 AND MY = 20 THEN ScrollField ATrack, 1
  IF MLB1 = 1 AND MY > 5 AND MY < 20 THEN
   IF MY > C THEN ScrollField ATrack, 16
   IF MY < C THEN ScrollField ATrack, -16
   IF MY = C THEN SMouseHeld = 1
  END IF
END IF

 'Dragging in the event field
IF MLB1 AND MX >= 46 AND MY >= 5 AND MX <= 63 THEN
  IF MY <= 8 - ((ATrack = 0) * 4) AND AField = 1 THEN
   IF MDD THEN CH$ = CHR$(13)
   AEvent(SGN(ATrack)) = MY - 5
 END IF
END IF

 'Dragging in the track field
IF MLB1 AND MX >= 67 AND MY >= 5 AND MX <= 77 AND MY <= 21 THEN
 IF AField = 2 THEN
  ATrack = MY - 5
 END IF
END IF

 'Convert mouse to key for playing. :)
IF MLB1 = 1 AND MY = 23 THEN
SELECT CASE MX
 CASE 3 TO 20: MLooped = MLooped XOR 1
 CASE 23 TO 33: CH$ = CHR$(0) + CHR$(63)
END SELECT
END IF

 'Keys
SELECT CASE CH$
 CASE CHR$(1)
   TrackScr(ATrack, 0) = 0
   TrackScr(ATrack, 1) = 0
   TrackScr(ATrack, 2) = TrackLen(ATrack) - 1
 CASE CHR$(3): IF TrackLen(ATrack) > 0 THEN CAS.Copy ATrack, TrackScr(ATrack, 1), TrackScr(ATrack, 2)
 CASE CHR$(22): IF CLen THEN IF CTrack THEN AWindow = 12 ELSE AWindow = 14
 CASE CHR$(0) + CHR$(60): AWindow = 7
 CASE CHR$(0) + CHR$(61): MLooped = MLooped XOR 1
 CASE CHR$(0) + CHR$(62): AWindow = 16
 CASE CHR$(0) + CHR$(63): CASPlaying = CASPlaying XOR 1: IF CASPlaying = 0 THEN CAS.Stop
 CASE CHR$(0) + CHR$(64): AWindow = 17
 CASE CHR$(0) + CHR$(65): AWindow = 19
 CASE CHR$(0) + CHR$(66): AWindow = 20
 CASE CHR$(0) + CHR$(67): AWindow = 21
 CASE CHR$(0) + CHR$(68): AWindow = 22
 CASE CHR$(0) + CHR$(133): AWindow = 23
 CASE CHR$(0) + CHR$(75): IF AField THEN AField = AField - 1
 CASE CHR$(0) + CHR$(77): IF AField < 2 THEN AField = AField + 1
 CASE CHR$(9): AField = (AField + 1) MOD 3
 CASE CHR$(0) + CHR$(15): AField = (AField + 2) MOD 3
END SELECT

' Choosing event
IF AField = 0 THEN
 SELECT CASE CH$
  CASE CHR$(0) + CHR$(71): ScrollField ATrack, -16384
  CASE CHR$(0) + CHR$(72): ScrollField ATrack, -1
  CASE CHR$(0) + CHR$(73): ScrollField ATrack, -16
  CASE CHR$(0) + CHR$(79): ScrollField ATrack, 16383
  CASE CHR$(0) + CHR$(80): ScrollField ATrack, 1
  CASE CHR$(0) + CHR$(81): ScrollField ATrack, 16
  CASE CHR$(0) + CHR$(82)
    IF TrackLen(ATrack) < 8000 THEN
     CH$ = ""
     C = TrackLen(ATrack)
     Undo = ATrack + 1
     DQBcopyLayer Undo, 19
     UndoTL = C
     PutTime ATrack, C, TTE&(ATrack, TrackLen(ATrack) - 1)
      IF AEvent(0) > 2 AND ATrack = 0 THEN
       SELECT CASE AEvent(0)
        CASE 3: PutByte4 0, C, 9
        CASE 4: PutByte4 0, C, 4
        CASE 5: PutByte4 0, C, 11
        CASE 6: PutByte4 0, C, 10
       END SELECT
      ELSE
       PutByte4 ATrack, C, AEvent(SGN(ATrack)) + 1
      END IF
     TrackLen(ATrack) = TrackLen(ATrack) + 1
     IF AEvent(0) = 7 THEN
      IF MeasUsed < 256 THEN
       PutByte4 ATrack, C, 14
       CAS.Sort.Track 0
      ELSE
       TrackLen(ATrack) = TrackLen(ATrack) - 1
      END IF
     END IF
     Modified = 1
    END IF
  CASE CHR$(0) + CHR$(83)
    CH$ = ""
    CAS.Delete ATrack, TrackScr(ATrack, 1), TrackScr(ATrack, 2)
    ScrollField ATrack, 0
    TrackScr(ATrack, 2) = TrackScr(ATrack, 1)
  CASE CHR$(127)
   IF Undo THEN
     DQBcopyLayer 19, Undo
     TrackLen(Undo - 1) = UndoTL
     Undo = 0
     CH$ = ""
   END IF
 END SELECT
END IF

' Choosing event
IF AField = 1 THEN
 IF ATrack THEN C = 3 ELSE C = 7
 I = AEvent(SGN(ATrack))
 P = (ATrack = 0)
 SELECT CASE UCASE$(CH$)
  CASE CHR$(13): REvent = AEvent(SGN(ATrack)) + 1
  CASE "P": IF ATrack THEN AEvent(1) = 0
  CASE "V": IF ATrack THEN AEvent(1) = 1 ELSE AEvent(0) = 3
  CASE "S": IF ATrack THEN AEvent(1) = 2 ELSE AEvent(0) = 0
  CASE "B": IF ATrack THEN AEvent(1) = 3
  CASE "C": IF P THEN AEvent(0) = 1
  CASE "R": IF P THEN AEvent(0) = 2
  CASE "L": IF P THEN AEvent(0) = 4
  CASE "I": IF P THEN AEvent(0) = 5
  CASE "G": IF P THEN AEvent(0) = 6
  CASE "M": IF P THEN AEvent(0) = 7
  CASE CHR$(0) + CHR$(71), CHR$(0) + CHR$(73)
     AEvent(SGN(ATrack)) = 0
  CASE CHR$(0) + CHR$(72): AEvent(SGN(ATrack)) = I + (I > 0)
  CASE CHR$(0) + CHR$(79), CHR$(0) + CHR$(81): AEvent(SGN(ATrack)) = C
  CASE CHR$(0) + CHR$(80): AEvent(SGN(ATrack)) = I - (I < C)
 END SELECT
END IF

' Choosing track
IF AField = 2 THEN
 SELECT CASE UCASE$(CH$)
  CASE "S": ATrack = 0
  CASE "0": ATrack = 10
  CASE "M": ATrack = 11
  CASE "T": ATrack = 12
  CASE "R": ATrack = 13
  CASE "A": ATrack = 14
  CASE "C": ATrack = 15
  CASE "K": ATrack = 16
  CASE CHR$(49) TO CHR$(57): ATrack = VAL(CH$)
  CASE CHR$(0) + CHR$(71): ATrack = 0
  CASE CHR$(0) + CHR$(72): ATrack = ATrack + (ATrack > 0)
  CASE CHR$(0) + CHR$(73): ATrack = ATrack - 4: IF ATrack < 0 THEN ATrack = 0
  CASE CHR$(0) + CHR$(80): ATrack = ATrack - (ATrack < 16)
  CASE CHR$(0) + CHR$(81): ATrack = ATrack + 4: IF ATrack > 16 THEN ATrack = 16
  CASE CHR$(0) + CHR$(79): ATrack = 16
 END SELECT
END IF

' REvent:
IF REvent AND AMenu = 0 AND Anything = 0 AND AWindow = 0 THEN
 CH$ = ""
 MLB1 = 2
 IF ATrack THEN
 AWindow = REvent + 23
 ELSE
  IF REvent >= 1 AND REvent <= 3 THEN
  AWindow = 28: Anything = REvent - 1
  ELSE
  AWindow = REvent + 25
  IF REvent > 6 THEN AWindow = AWindow - 1
  END IF
 END IF
END IF

END SUB

SUB PutTime (Track, Event, TTTT&)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
DQBpset Track + 1, JX, JY, TTTT& AND 255
DQBpset Track + 1, JX + 1, JY, (TTTT& \ 256) AND 255
DQBpset Track + 1, JX + 2, JY, (TTTT& \ 65536)

END SUB

SUB ScrollField (Trk, IncDec)

' Reset positions
IF TrackLen(Trk) = 0 THEN
 TrackScr(Trk, 0) = 0
 TrackScr(Trk, 1) = 0
 TrackScr(Trk, 2) = 0
 EXIT SUB
END IF

' Correct any dead bottoms
IF TrackLen(Trk) - TrackScr(Trk, 0) < 16 AND TrackLen(Trk) > 15 THEN
 TrackScr(Trk, 0) = TrackLen(Trk) - 16
END IF

' Highlight move
C = TrackScr(Trk, 1)
C = C + IncDec
IF C < 0 THEN C = 0
IF C > TrackLen(Trk) - 1 THEN C = TrackLen(Trk) - 1
TrackScr(Trk, 1) = C

' Inc and Dec camera
C = TrackScr(Trk, 1) - TrackScr(Trk, 0)
IF C > 15 THEN
TrackScr(Trk, 0) = TrackScr(Trk, 0) + (C - 15)
END IF
IF C < 0 THEN
TrackScr(Trk, 0) = TrackScr(Trk, 0) + C
END IF

' Key shift
IF SHIFT = 0 THEN TrackScr(Trk, 2) = TrackScr(Trk, 1)

END SUB

SUB StdInp (W, M, SE, A)          ' Standard input

' New Press
IF A AND MLB1 = 1 THEN
W = A - 1: DummyInteger(1) = A
END IF

' Highlight
IF MLB1 AND A > 0 AND DummyInteger(1) = A THEN
 DummyInteger(2) = A
 ELSE
 DummyInteger(2) = 0
END IF

' Space Bar
IF SBAR THEN DummyInteger(2) = W + 1

' Release
IF DummyInteger(1) AND MLB1 = -1 THEN
IF A > M - 2 THEN SE = 2 ELSE DummyInteger(1) = 0
END IF

END SUB

FUNCTION Str2Tim& (Text$)

C1 = INSTR(Text$, ":")
L& = VAL(LEFT$(Text$, C1 - 1))
R& = VAL(RIGHT$(Text$, LEN(Text$) - C1))
Str2Tim& = (TickSig * L&) + R&

END FUNCTION

FUNCTION TTE& (Track, Event)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
FP& = DQBpoint(Track + 1, JX, JY)
FP& = FP& + (DQBpoint(Track + 1, JX + 1, JY) * 256&)
FP& = FP& + (DQBpoint(Track + 1, JX + 2, JY) * 65536)
TTE& = FP&

END FUNCTION

