' This converts CXE files into a large WAV file.

'$INCLUDE: 'DIRECTQB.BI'
DECLARE FUNCTION ByteCode% (Pointer&)
DECLARE SUB Prompt ()
DECLARE SUB MakeWave ()

COMMON SHARED CXEFile$, WAVFile$, WAVfileLength, FadeLen
COMMON SHARED MusicPlaying, MVwait AS LONG, MVptr AS LONG, MVLoop

'$STATIC
DIM SHARED Pitch(30) AS INTEGER               ' Semitone table
DIM SHARED WavLen2(15) AS LONG               ' Length of the WAVs
DIM SHARED ChannelFreq(15) AS INTEGER       ' Sample Rate
DIM SHARED ChannelLoop(15) AS INTEGER      ' Loop samples
DIM SHARED ChannelPlay(15) AS INTEGER     ' Is the sample currently playing?
DIM SHARED ChannelSnd(15) AS INTEGER      ' What Sound slot is being played?
DIM SHARED ChannelVol(15) AS INTEGER      ' Volume for each channel
DIM SHARED ChannelByte(15) AS INTEGER    ' Sample data bytes
DIM SHARED WAVcount(15) AS LONG        ' PC for channel playing
'$DYNAMIC

Prompt
MakeWave

FUNCTION ByteCode (Pointer&)

Xtm = Pointer& MOD 320
Ytm = (Pointer& \ 320) MOD 200
Ltm = (Pointer& \ 64000) + 1
ByteCode = DQBpoint(Ltm, Xtm, Ytm)

END FUNCTION

SUB MakeWave

' Layers 1 TO 16 = Sound data
' Layers 1 TO 3 = Music data

' This will create the output 8-bit mono WAV file at 22050 Hz"

IF DQBinit(3, 16, 0) THEN DQBclose: PRINT DQBerror$: END
DQBfpu


' Output WAV file header
Head$ = "RIFF"
Head$ = Head$ + MKL$(FileSize - 8)
Head$ = Head$ + "WAVEfmt "
Head$ = Head$ + CHR$(16) + STRING$(3, 0)
Head$ = Head$ + CHR$(1) + CHR$(0) + CHR$(1) + CHR$(0)
Head$ = Head$ + MKL$(22050)          ' Sample Rate
Head$ = Head$ + MKL$(22050)          ' Byte Rate
Head$ = Head$ + CHR$(1) + CHR$(0)    ' Channels
Head$ = Head$ + CHR$(8) + CHR$(0)    ' Bit depth
Head$ = Head$ + "data"
Head$ = Head$ + MKL$(FileSize - 44)  ' Actual data length

OPEN WAVFile$ FOR BINARY AS #1
PUT #1, , Head$

' ==================================================
' MUSIC CODE LOADING
' ==================================================

OPEN CXEFile$ FOR BINARY ACCESS READ AS #2

IF LOF(2) = 0 THEN
  CLOSE #2
  KILL File$
  DQBclose
  PRINT "Music file not found: " + CXEFile$
  END
END IF

F$ = SPACE$(8)
GET #2, , F$
IF F$ <> "CCMusic" THEN
  CLOSE #2
  DQBclose
  PRINT "Invalid file: " + CXEFile$
  END
END IF

F$ = SPACE$(12)
FOR A = 0 TO 15
GET #2, , F$             ' Grab sound files
BB$ = ""
FOR C = 1 TO 12
L = ASC(MID$(F$, C, 1))
IF L > 32 AND L < 126 THEN BB$ = BB$ + MID$(F$, C, 1)
NEXT
IF BB$ <> "" THEN
 IF DQBloadSound(A + 1, "MUSIC\" + BB$) THEN
  CLOSE #2
  DQBclose
  PRINT DQBerror$
  END
 END IF
 OPEN "MUSIC\" + BB$ FOR BINARY ACCESS READ AS #3
  JOIN$ = "1234"
  GET #3, 41, JOIN$
  WavLen2(A) = CVL(JOIN$)
  IF WavLen2(A) > 65535 THEN WavLen2(A) = 65535
  WavLen2(A) = WavLen2(A) * 32768
 CLOSE #3
END IF
NEXT

'       Grab the rest of the DATA
L = 1
F$ = SPACE$(320)
DEF SEG = VARSEG(F$)
DO
GET #2, , F$
FOR X = 0 TO 319
DQBpset L, X, Y, PEEK(SADD(F$) + X)
NEXT
Y = Y + 1: IF Y = 200 THEN Y = 0: L = L + 1: IF L = 4 THEN EXIT DO
LOOP UNTIL EOF(2)
CLOSE #2

' ==================================================
' MUSIC CODE PLAYING
' ==================================================

' Make semitone table
G! = 31183
FOR P = 30 TO 0 STEP -1
Pitch(P) = CINT(G!)
G! = G! * .943875
NEXT
FOR P = 0 TO 15
ChannelByte(P) = 127   ' Silence
ChannelVol(P) = 63     ' Deafault Volume
NEXT

' =======================================
' ===================== OUTPUT WAVE WRITE
' =======================================
OutputChunk$ = STRING$(315, 127)
DEF SEG = VARSEG(OutputChunk$)
StrOff = SADD(OutputChunk$)
Cycle315:

FOR GK = 0 TO 314

FOR K = 0 TO 15                ' Get ChannelBytes

 IF ChannelPlay(K) THEN
   GD& = WAVcount(K)
   RO& = GD& \ 32768
   X = RO& MOD 320           ' INC wave counter if playing
   Y = RO& \ 320
   J = ChannelSnd(K)
   ChannelByte(K) = DQBpoint(4 + J, X, Y)
   GD& = GD& + ChannelFreq(K) * 32768 \ 22050
  
    IF GD& >= WavLen2(J) THEN      ' Stop or repeat
     IF ChannelLoop(K) THEN
      GD& = GD& - WavLen2(J)
     ELSE
      ChannelPlay(K) = 0
      ChannelByte(K) = 127
      GD& = 0
     END IF
    END IF
 ELSE
  ChannelByte(K) = 127
 END IF

  ' Volume our byte
 MBit = (ChannelByte(K) - 127) * ChannelVol(K) \ 63
 ChannelByte(K) = MBit + 127
 WAVcount(K) = GD&

NEXT K

  ' Mix our channels
ByteByte = 0
FOR K = 0 TO 15
ByteByte = ByteByte + (ChannelByte(K) - 127)
NEXT K

ByteByte = ByteByte + 127
IF ByteByte < 0 THEN ByteByte = 0
IF ByteByte > 255 THEN ByteByte = 255

POKE GK + StrOff, ByteByte
NEXT GK

PUT #1, , OutputChunk$      ' Write WAV block
OLen& = OLen& + 315

IF OLen& > (WAVfileLength * 1000&) THEN GOTO DoneMusic
PRINT "Music conversion percentage complete: "; INT(OLen& * 100& / (WAVfileLength * 1000&))

IF MVwait > 0 THEN MVwait = MVwait - 1: GOTO Cycle315

' ================================
' ===================== MUSIC PLAY
' ================================
BackAgain:

Xtm = MVptr MOD 320
Ytm = (MVptr \ 320) MOD 200
Ltm = (MVptr \ 64000) + 1
Byte1 = DQBpoint(Ltm, Xtm, Ytm)

'    Stop music completely
IF Byte1 = 0 THEN GOTO DoneMusic

'     Get our bytes to work with music pointer
MVptr = MVptr + 1

IF Byte1 > 84 THEN
 Xtm = MVptr MOD 320
 Ytm = (MVptr \ 320) MOD 200
 Ltm = (MVptr \ 64000) + 1
 Byte2 = DQBpoint(Ltm, Xtm, Ytm)
 MVptr = MVptr + 1
END IF

IF Byte1 > 122 THEN
 Xtm = MVptr MOD 320
 Ytm = (MVptr \ 320) MOD 200
 Ltm = (MVptr \ 64000) + 1
 Byte3 = DQBpoint(Ltm, Xtm, Ytm)
 MVptr = MVptr + 1
END IF

IF Byte1 > 140 THEN
 Xtm = MVptr MOD 320
 Ytm = (MVptr \ 320) MOD 200
 Ltm = (MVptr \ 64000) + 1
 Byte4 = DQBpoint(Ltm, Xtm, Ytm)
 MVptr = MVptr + 1
END IF

IF Byte1 > 190 THEN
 Xtm = MVptr MOD 320
 Ytm = (MVptr \ 320) MOD 200
 Ltm = (MVptr \ 64000) + 1
 Byte5 = DQBpoint(Ltm, Xtm, Ytm)
 MVptr = MVptr + 1
END IF

SELECT CASE Byte1

'       1 Byte
CASE 1 TO 32: MVwait = Byte1 - 1: GOTO Cycle315

CASE 33

 FOR I = 0 TO 15
  ChannelPlay(I) = 0    ' Stop channels
  WAVcount(I) = 0       ' Reset counters
  ChannelByte(I) = 127  ' Silence values
 NEXT

CASE 34: MVLoop = 0: MVptr = 0
CASE 35: MVLoop = (MVLoop + 1) AND 255
CASE 36: MVLoop = (MVLoop - 1) AND 255

CASE 37 TO 52
  
  WAVcount(Byte1 - 37) = 0
  ChannelFreq(Byte1 - 37) = 22050
  ChannelLoop(Byte1 - 37) = 0
  ChannelPlay(Byte1 - 37) = 1
  ChannelSnd(Byte1 - 37) = Byte1 - 37
  
CASE 53 TO 68
  
  WAVcount(Byte1 - 53) = 0
  ChannelFreq(Byte1 - 53) = 11025
  ChannelLoop(Byte1 - 53) = 0
  ChannelPlay(Byte1 - 53) = 1
  ChannelSnd(Byte1 - 53) = Byte1 - 53

CASE 69 TO 84

  WAVcount(Byte1 - 69) = 0             ' Program counter of Channels
  ChannelFreq(Byte1 - 69) = 5513       ' Sample playback rate
  ChannelLoop(Byte1 - 69) = 0          ' Looping?
  ChannelPlay(Byte1 - 69) = 1          ' Playing?
  ChannelSnd(Byte1 - 69) = Byte1 - 69  ' Sound slot

'       2 Bytes
CASE 85: MVLoop = Byte2 AND 255
CASE 86: MVLoop = (MVLoop + Byte2) AND 255
CASE 87: MVLoop = (MVLoop - Byte2) AND 255
CASE 88

 FOR I = 0 TO 15
  ChannelVol(I) = Byte2 AND 63       ' Set all channels volume
 NEXT

CASE 89
 K = Byte2 AND 15
 ChannelPlay(K) = 0        ' Stop certain voice
 WAVcount(K) = 0
 ChannelByte(K) = 127

CASE 90 TO 105
 ChannelVol(Byte1 - 90) = Byte2 AND 63  ' Set certain channel volume

CASE 106
 MVwait = Byte2
 GOTO Cycle315

CASE 107 TO 122

 K = Byte1 - 107
 WAVcount(K) = 0
 ChannelPlay(K) = 1
 ChannelSnd(K) = K
 ChannelFreq(K) = Pitch(Byte2 AND 31)
 ChannelLoop(K) = Byte2 \ 32

CASE 123  '       3 Bytes

 ' DQBplaySound (B2 AND 15), (B2 \ 16), Pitch(B3 AND 31), B3 \ 32
 K = Byte2 \ 16
 WAVcount(K) = 0
 ChannelPlay(K) = 1
 ChannelSnd(K) = Byte2 AND 15
 ChannelFreq(K) = Pitch(Byte3 AND 31)
 ChannelLoop(K) = Byte3 \ 32

CASE 124: MVwait = (Byte3 * 256) + Byte2: GOTO Cycle315
CASE 125 TO 140

 K = Byte1 - 125
 ChannelFreq(K) = (Byte3 * 256) + Byte2

'       4 Bytes
CASE 141
 MVwait = (Byte4 * 65536) + (Byte3 * 256) + Byte2
 GOTO Cycle315

CASE 142 TO 157
 IF MVLoop < (Byte1 - 142) THEN
  MVptr = (Byte4 * 65536) + (Byte3 * 256) + Byte2
 END IF

CASE 158 TO 173
 IF MVLoop > (Byte1 - 158) THEN
  MVptr = (Byte4 * 65536) + (Byte3 * 256) + Byte2
 END IF

CASE 174 TO 189
 IF MVLoop = (Byte1 - 174) THEN
  MVptr = (Byte4 * 65536) + (Byte3 * 256) + Byte2
 END IF

CASE 190
  MVptr = (Byte4 * 65536) + (Byte3 * 256) + Byte2

'       5 Bytes
CASE 191
 IF MVLoop < Byte2 THEN MVptr = (Byte5 * 65536) + (Byte4 * 256) + Byte3

CASE 192
 IF MVLoop > Byte2 THEN MVptr = (Byte5 * 65536) + (Byte4 * 256) + Byte3

CASE 193
 IF MVLoop = Byte2 THEN MVptr = (Byte5 * 65536) + (Byte4 * 256) + Byte3

END SELECT

GOTO BackAgain


DoneMusic:

' Create output length
M& = LOF(1) - 8
PUT #1, 5, M&
M& = M& - 36
PUT #1, 41, M&

CLOSE #1

DQBclose

END SUB

SUB Prompt

CC$ = COMMAND$

CXEFile$ = "MUSIC\0.CXE"
WAVFile$ = "NEW2.WAV"
WAVfileLength = 8000
FadeLen = 0
EXIT SUB

' Help screen

IF INSTR(CC$, "HELP") OR INSTR(CC$, "?") OR INSTR(CC$, "HLP") THEN
 PRINT "CXE2WAV [CXE file], [New WAV file], [Byte length], [Fade seconds 0-8 0=none]"
 PRINT
 PRINT "The byte length is used to cut off looping songs. You may also"
 PRINT "fade the master volume of the song in and out at the beginning"
 PRINT "and ending. The specified byte length of the new WAV output will"
 PRINT "be multiplied by 1,000 so be warned! If the CXE song command " + CHR$(34) + "STOP" + CHR$(34) + " has"
 PRINT "been encountered, it will automatically end the conversion process."
 PRINT
 PRINT "The below example will convert MUSIC\C.CXE to MyOutput.WAV at"
 PRINT "4,081,000 bytes with fading in and out with each having 2 seconds"
 PRINT "of fading transition."
 PRINT
 COLOR 11
 PRINT "CXE2WAV MUSIC\C.CXE, MyOutput.WAV, 4081, 2"
 PRINT
END
END IF

CXEname01:
INPUT "Input CXE file for conversion: ", CXEFile$
IF LTRIM$(RTRIM$(CXEFile$)) = "" THEN END

WAVname01:
INPUT "Output WAV file name: ", WAVFile$
IF LTRIM$(RTRIM$(WAVFile$)) = "" THEN END

LengthFile01:
INPUT "Length of output WAV file in kilobytes: (No commas): ", WAVfileLength
IF WAVfileLength = 0 THEN END

FadeLen01:
INPUT "Fade in/out length in seconds: (0=None, 1-8=Seconds): ", FadeLen
IF FadeLen < 0 OR FadeLen > 8 THEN GOTO FadeLen01

SkipAll:
PRINT "File name = " + CXEFile$
PRINT "WAV file = " + WAVFile$
PRINT "Byte Length = "; WAVfileLength * 1000&
PRINT "Fade length = "; FadeLen

END SUB

