; These routines are written by Angelo Mottola.
; Some of these routines are modified by me, James Robert Osborne.

.MODEL medium,basic
.386
.STACK 100h

EMSmoveStruc STRUC
  len         DD  ?
  sourceType  DB  ?
  sourceHdl   DW  ?
  sourceOf    DW  ?
  sourceSegPg DW  ?
  destType    DB  ?
  destHdl     DW  ?
  destOff     DW  ?
  destSegPg   DW  ?
EMSmoveStruc ENDS

BSVheaderType STRUC
  SourceSeg   DW  ?
  SourceOff   DW  ?
  BSVlen      DW  ?
  BSVxSize    DW  ?
  BSVySize    DW  ?
BSVheaderType ENDS

.DATA

PUBLIC EMMid,EMSseg,EMShdl,EMSpage,EMSallocated,BaseLayer,BaseSet
PUBLIC PutMode,FontBuffer,CharLen,PicORmask
PUBLIC Buffer,KeyActive,OldInt9seg,OldInt9off,KeyFlags,KeyStatus
PUBLIC SoundActive,SoundPage,NumSounds,SoundLen,VolActive,VolSeg,BaseAddr,IRQ
PUBLIC OldIRQseg,OldIRQoff,OldInt24seg,OldInt24off,LastError

BSVheader     BSVheaderType <>             ; BSAVE file header
SinTable    DW 256,256,256,255,255,254,253,252,251,250,248,247,245,243,241,239,237,234,231,229,226,223,220,216,213,209,206,202,198,194,190,185
            DW 181,177,172,167,162,157,152,147,142,137,132,126,121,115,109,104,98,92,86,80,74,68,62,56,50,44,38,31,25,19,13,6
            DW 0,-6,-13,-19,-25,-31,-38,-44,-50,-56,-62,-68,-74,-80,-86,-92,-98,-104,-109,-115,-121,-126,-132,-137,-142,-147,-152,-157,-162,-167,-172,-177
            DW -181,-185,-190,-194,-198,-202,-206,-209,-213,-216,-220,-223,-226,-229,-231,-234,-237,-239,-241,-243,-245,-247,-248,-250,-251,-252,-253,-254,-255,-255,-256,-256
            DW -256,-256,-256,-255,-255,-254,-253,-252,-251,-250,-248,-247,-245,-243,-241,-239,-237,-234,-231,-229,-226,-223,-220,-216,-213,-209,-206,-202,-198,-194,-190,-185
            DW -181,-177,-172,-167,-162,-157,-152,-147,-142,-137,-132,-126,-121,-115,-109,-104,-98,-92,-86,-80,-74,-68,-62,-56,-50,-44,-38,-31,-25,-19,-13,-6
            DW 0,6,13,19,25,31,38,44,50,56,62,68,74,80,86,92,98,104,109,115,121,126,132,137,142,147,152,157,162,167,172,177
            DW 181,185,190,194,198,202,206,209,213,216,220,223,226,229,231,234,237,239,241,243,245,247,248,250,251,252,253,254,255,255,256,256

deltax        DW  ?               ; DQBline stuff
deltay        DW  ?               ; DQBline stuff
d             DW  ?               ; DQBline stuff
dinc1         DW  ?               ; DQBline stuff
dinc2         DW  ?               ; DQBline stuff
xinc1         DW  ?               ; DQBline stuff
xinc2         DW  ?               ; DQBline stuff
yinc1         DW  ?               ; DQBline stuff
yinc2         DW  ?               ; DQBline stuff
FirstEntry    DW  ?               ; DQBline stuff
LastEntry     DW  ?               ; DQBline stuff
fx            DW  ?               ; DQBline stuff
fy            DW  ?               ; DQBline stuff
LibActive     DB  0               ; Has the library been initialized?
EMMid         DB  'EMMXXXX0'      ; EMM id string
EMSseg        DW  ?               ; EMS pageframe segment
EMShdl        DW  ?               ; EMS handle being used by the library
EMSpage       DW  ?               ; Current EMS page
EMSallocated  DW  ?               ; Amount of allocated EMS memory
EMSmove       EMSmoveStruc <>     ; Data moving structure
DataPage      DW  ?               ; Starting data EMS logical page
BaseLayer     DW  10 dup(0)       ; segments of 10 extra layers in base memory
BaseSet       DB  10 dup(0)       ; base layers used flags
VGAon         DB  0               ; Are we in VGA mode?
PutMode       DW  0               ; Sprite put mode (0:transparent, 1:solid)
FontBuffer    DB  2048 dup (?)    ; Internal font buffer
CharLen       DB  257 dup(8)      ; Internal characters length buffer
Buffer        DB  ?               ; File I/O byte buffer
KeyActive     DB  0               ; Is the keyboard handler already active?
OldInt9seg    DW  ?               ; Original int 9h segment
OldInt9off    DW  ?               ; Original int 9h offset
KeyFlags      DB  ?               ; Original keyboard flags status
KeyStatus     DB  128 dup(0)      ; Status of each key (0:released, 1:pressed)
SoundActive   DB  0               ; Has the SB custom IRQ been installed?
SoundPage     DW  ?               ; EMS page where sounds data begins
NumSounds     DB  0               ; Number of allocated sounds
PicORmask     DB  ?               ; OR pic mask to set IRQ
BaseAddr      DW  0220h           ; SB base address
IRQ           DB  7               ; SB IRQ
VolActive     DB  0               ; Has volume table been installed?
VolSeg        DW  0               ; Volume table segment
OldIRQseg     DW  ?               ; Old IRQ interrupt segment
OldIRQoff     DW  ?               ; Old IRQ interrupt offset
SoundLen      DW  256 dup(0)      ; Sounds length (256 sounds allowed)
OldInt24seg   DW  ?               ; Original int 24h segment
OldInt24off   DW  ?               ; Original int 24h offset
OldInt8       DD  ?               ; Old timer ISR address
LastError     DB  29              ; Last error code number
Blaster       DB  'BLASTER='      ; BLASTER environmental variable
DMA           DB  1               ; SB DMA channel
PicANDmask    DB  ?               ; AND pic mask to clear IRQ
DMA_Page      DW  ?               ; DMA page register
DMA_Base      DW  ?               ; DMA base address
DMA_Count     DW  ?               ; DMA count register
SamplingRate  DW  22050           ; Sampling rate (default = 22050 Hz)
Playing       DB  0               ; Number of sounds currently playing
PauseSound    DB  0               ; Sound pause flag
Channels      DW  8               ; Number of channels used for sample mixing
SamplePtr     DW  32 dup(0)       ; Pointer to sample
LowCount      DW  32 dup(0)       ; Fractional counter (for CF addition)
HighCount     DW  32 dup(0)       ; Integer part of CF-based counter
Counter       DW  32 dup(0)       ; Counter delta
VoiceSound    DW  32 dup(0)       ; Sound number being played on each voice
VoiceLoop     DW  32 dup(0)       ; Voice loop flags
VoiceVol      DW  32 dup(63)      ; Volume of each voice
VoiceLoopEnd  DW  32 dup(0)       ; Loop end point
VoiceLoopLen  DW  32 dup(0)       ; Loop length
BUFFERLEN     EQU 512             ; Buffer length in bytes
MixPtr        DW  0               ; Pointer to actual mixer buffer position
MixBuffer     DW  (BUFFERLEN/2) dup(0)  ; Mixing sound buffer
SoundBuffer   DB  BUFFERLEN dup(?)      ; Output sound buffer

INCLUDE errors.inc                ; Error messages

.CODE

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC MapEMS
MapEMS PROC FAR
  MOV EMSpage,DX  
  MOV BX,DX
  MOV DX,EMShdl
  XOR AX,AX       
MapPage:
  MOV AH,44h      
  INT 67h         
  INC BX          
  INC AL          
  CMP AL,4        
  JNE MapPage
  RET
MapEMS ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC GetLayerSeg
GetLayerSeg PROC FAR
  CMP BX,0        
  JLE SHORT NotEMS
  DEC BX
  SHL BX,2      
  CMP BX,EMSpage
  JNE SHORT OnDifferentPage
  MOV CX,EMSseg   
  RET
OnDifferentPage:
  MOV EMSpage,BX
  MOV DX,EMShdl
  MOV AX,4400h
  INT 67h      
  INC BX       
  MOV AX,4401h
  INT 67h
  INC BX
  MOV AX,4402h
  INT 67h
  INC BX
  MOV AX,4403h
  INT 67h
  MOV CX,EMSseg
  RET          
NotEMS:
  JNZ SHORT NotVIDEO
  MOV CX,0A000h
  RET
NotVIDEO:
  AND BX,0111111111111111b
  CMP BaseSet[BX],0
  JE BaseNotSet
  SHL BX,1
  MOV CX,BaseLayer[BX]
  RET
BaseNotSet:
  MOV CX,0A000h
  RET 
GetLayerSeg ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC WriteBuffer
WriteBuffer PROC FAR
  PUSH DS
  PUSH AX
  PUSH CX
  PUSH DX
  MOV DX,OFFSET Buffer
  MOV AX,@DATA
  MOV DS,AX
  MOV CX,1
  MOV AH,40h
  INT 21h
  POP DX
  POP CX
  POP AX
  POP DS
  RET
WriteBuffer ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC ReadBuffer
ReadBuffer PROC FAR
  PUSH DS
  PUSH AX
  PUSH CX
  PUSH DX
  MOV DX,OFFSET Buffer
  MOV AX,@DATA
  MOV DS,AX
  MOV CX,1
  MOV AH,3Fh
  INT 21h
  POP DX
  POP CX
  POP AX
  POP DS
  RET
ReadBuffer ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC HookInt24
HookInt24 PROC FAR
  PUSH DS
  MOV AX,3524h
  INT 21h
  MOV AX,@DATA
  MOV DS,AX
  MOV OldInt24seg,ES
  MOV OldInt24off,BX
  POP DS
  MOV AX,SEG CriticalISR
  MOV DX,OFFSET CriticalISR
  PUSH DS
  MOV DS,AX
  MOV AX,2524h
  INT 21h
  POP DS
  RET
CriticalISR:
  MOV AL,3
  IRET
HookInt24 ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC UnhookInt24
UnhookInt24 PROC FAR
  PUSH AX
  PUSH DS
  MOV AX,@DATA
  MOV DS,AX
  MOV DX,OldInt24off
  MOV AX,OldInt24seg
  MOV DS,AX
  MOV AX,2524h
  INT 21h
  POP DS
  POP AX
  RET
UnhookInt24 ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBinit
DQBinit PROC
  PUSH BP
  MOV BP,SP
  PUSH DS
  CMP LibActive,1
  JE Error_AlreadyUp
  MOV AX,@DATA
  MOV ES,AX
  XOR AX,AX
  MOV CX,10
  MOV DI,OFFSET BaseSet
  REP STOSB
  MOV DI,OFFSET FontBuffer
  XOR AX,AX
  MOV DS,AX
  MOV SI,DS:[07Ch]
  MOV AX,DS:[07Eh]
  SUB SI,1024
  MOV DS,AX
  MOV CX,512
  REP MOVSD
  MOV EAX,08080808h
  MOV CX,64
  MOV DI,OFFSET CharLen
  REP STOSD
  STOSB
  POP DS
  PUSHF
  MOV CX,7000h    
  PUSH CX
  POPF
  PUSHF           
  POP AX          
  AND AX,7000h    
  SETNZ AL
  XOR AH,AH       
  POPF
  TEST AX,AX
  JE Error_NoCPU
  XOR AX,AX
  MOV EMSallocated,AX
  MOV DX,[BP+10]
  SHL DX,2
  MOV SoundPage,DX
  MOV BX,[BP+8]
  SHL BX,2
  ADD DX,BX
  MOV DataPage,DX
  MOV DX,[BP+8]
  MOV NumSounds,DL
  MOV DX,[BP+10]  
  ADD DX,[BP+8]
  SHL DX,2
  MOV BX,[BP+6]
  OR BX,BX
  JZ SHORT @F
  SHR BX,4
  INC BX
  ADD DX,BX
@@:
  TEST DX,DX      
  JE MemDone      
  MOV ES,AX
  MOV BX,19Eh     
  MOV AX,ES:[BX]  
  MOV ES,AX       
  MOV DI,10
  MOV SI,OFFSET EMMid
  MOV CX,8        
  REPE CMPSB
  JNE Error_NoEMS 
  MOV AH,42h
  INT 67h         
  MOV DX,[BP+10]  
  ADD DX,[BP+8]
  SHL DX,2        
  MOV CX,[BP+6]
  OR CX,CX
  JZ SHORT @F
  SHR CX,4
  INC CX
  ADD DX,CX
@@:
  CMP BX,DX       
  JL Error_NotEnoughEMS
  MOV EMSallocated, DX
  MOV AH,43h
  MOV BX,DX
  INT 67h        
  MOV EMShdl,DX  
  MOV AH,41h
  INT 67h        
  MOV EMSseg,BX  
  MOV ES,BX
  MOV BX,[BP+8]
  TEST BX,BX
  JE CheckLayers
  MOV EAX,080808080h
  ADD BX,[BP+10]
InitSounds:
  MOV DX,BX
  DEC DX
  SHL DX,2
  PUSH AX
  PUSH BX
  PUSH DX
  CALL MapEMS
  POP DX
  POP BX
  POP AX
  XOR DI,DI
  MOV CX,16384
  REP STOSD
  DEC BX
  JNZ InitSounds
CheckLayers:
  MOV BX,[BP+10]
  TEST BX,BX
  JE MemDone
  XOR EAX,EAX
InitLayers:
  MOV DX,BX
  DEC DX
  SHL DX,2
  PUSH AX
  PUSH BX
  PUSH DX
  CALL MapEMS
  POP DX
  POP BX
  POP AX
  XOR DI,DI
  MOV CX,16384
  REP STOSD
  DEC BX
  JNZ InitLayers
  XOR DX,DX
  CALL MapEMS  
  XOR AX,AX    
  JMP MemDone
Error_AlreadyUp:
  MOV AX,4     
  MOV LastError, 0
  JMP EndInit
Error_NoCPU:
  MOV AX,1     
  MOV LastError, 1
  JMP EndInit
Error_NoEMS:
  MOV AX,2     
  MOV LastError, 2
  JMP EndInit
Error_NotEnoughEMS:
  MOV AX,3     
  MOV LastError, 3
  JMP EndInit
MemDone:
  MOV LibActive, 1
  XOR AX,AX
EndInit:
  POP BP
  RET 6
DQBinit ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBmapLayer
DQBmapLayer PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+6]
  CALL GetLayerSeg
  MOV AX,CX
  POP BP
  RET 2
DQBmapLayer ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC xDQBerror
xDQBerror PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV AX,[BP+10]
  MOV ES,AX
  MOV DI,[BP+8]
  MOV AX,@DATA
  MOV DS,AX
  MOV SI,OFFSET ErrorMsg
  XOR CX,CX
  MOV CL,LastError
  SHL CX,5
  ADD SI,CX
  MOV CX,8
  REP MOVSD
  POP BP
  POP DS
  RET 4
xDQBerror ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBclose
DQBclose PROC
  CMP LibActive,1
  JE SHORT @F
  RET
@@:
  CMP KeyActive, 0
  JE NoRemoveKey
  PUSH DS
  MOV DX,OldInt9off
  MOV AX,OldInt9seg
  MOV DS,AX
  MOV AX,2509h
  INT 21h
  POP DS
  MOV BL,KeyFlags
  MOV AX,040h
  MOV ES,AX
  MOV SI,017h
  MOV ES:[SI],BL
  MOV KeyActive,0
NoRemoveKey:
  CMP SoundActive,0
  JE NoRemoveSB
  MOV DX,BaseAddr
  ADD DX,06h
  MOV AL,1
  OUT DX,AL
  IN AL,DX
  IN AL,DX
  IN AL,DX
  IN AL,DX
  XOR AL,AL
  OUT DX,AL
  ADD DX,08h
  XOR CX,CX
WaitRead1:
  DEC CX
  JZ EndReadDSP1
  IN AL,DX
  OR AL,AL
  JNS WaitRead1
EndReadDSP1:
  SUB DX,4
  IN AL,DX   
  IN AL,021h
  XOR AX,AX
  MOV ES,AX
  MOV AL,IRQ
  ADD AL,8
  MOV SI,AX
  SHL SI,2
  CLI
  MOV AX,OldIRQoff
  MOV ES:[SI],AX
  MOV AX,OldIRQseg
  MOV ES:[SI+2],AX  
  STI
  MOV SoundActive,0
NoRemoveSB:
  CMP VolActive,0
  JE NoRemoveVol
  MOV AH,049h
  MOV BX,VolSeg
  MOV ES,BX
  INT 21h
  MOV VolActive,0
NoRemoveVol:
  CMP EMSallocated,0 
  JE NoDealloc      
  MOV AH,45h        
  MOV DX,EMShdl
  INT 67h
NoDealloc:
  XOR SI,SI
DeallocBase:
  CMP BaseSet[SI],0
  JE NoDeallocBase
  MOV BX,SI
  SHL BX,1
  PUSH SI
  MOV CX,BaseLayer[BX]
  MOV ES,CX
  MOV AH,49h
  INT 21h
  POP SI
  MOV BaseSet[SI],0
NoDeallocBase:
  INC SI
  CMP SI,10
  JB DeallocBase
  XOR CX,CX
  CMP VGAon,0
  JE NoTextMode
  MOV AX,03h
  INT 010h
  MOV VGAon,0
NoTextMode:
  MOV LibActive,0
  RET
DQBclose ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBinitVGA
DQBinitVGA PROC
  MOV AX,013h
  INT 010h
  MOV VGAon,1
  RET
DQBinitVGA ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBsetBaseLayer
DQBsetBaseLayer PROC
  PUSH BP
  MOV BP,SP
  MOV SI,[BP+6]
  AND SI,0111111111111111b
  CMP SI,10
  JGE ErrorBaseLayer
  CMP BaseSet[SI],0
  JNE ErrorBaseLayer
  SHL SI,1
  MOV AH,048h
  MOV BX,4000
  INT 021h
  JC ErrorBaseLayer
  MOV BaseLayer[SI],AX
  SHR SI,1
  MOV BaseSet[SI],1
  MOV ES,AX
  PUSH AX
  XOR DI,DI
  XOR EAX,EAX
  MOV CX,16000
  REP STOSD
  POP AX
  POP BP
  RET 2
ErrorBaseLayer:
  XOR AX,AX
  MOV LastError,7
  POP BP
  RET 2
DQBsetBaseLayer ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBcopyLayer
DQBcopyLayer PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+10] 
  MOV DX,[BP+8]  
  TEST BX,BX
  JLE OneInRAM   
  TEST DX,DX
  JLE OneInRAM   
  MOV DX,EMShdl  
  MOV AX,EMSseg
  MOV DS,AX      
  MOV ES,AX      
  DEC BX
  SHL BX,2
  MOV AX,4400h
  INT 67h
  MOV AX,4401h
  INC BX
  INT 67h
  MOV BX,[BP+8]
  DEC BX
  SHL BX,2
  MOV AX,4402h
  INT 67h
  MOV AX,4403h  
  INC BX        
  INT 67h     
  XOR SI,SI
  MOV DI,8000h
  MOV CX,2000h
  REP MOVSD
  MOV AX,4400h
  MOV BX,[BP+10]
  DEC BX
  SHL BX,2
  ADD BX,2
  INT 67h
  MOV AX,4401h
  INC BX
  INT 67h
  MOV BX,[BP+8]
  DEC BX
  SHL BX,2
  ADD BX,2
  MOV AX,4402h
  INT 67h
  MOV AX,4403h
  INC BX
  INT 67h
  XOR SI,SI
  MOV DI,8000h
  MOV CX,2000h
  REP MOVSD
  MOV AX,@DATA
  MOV DS,AX
  MOV DX,EMSpage
  CALL MapEMS
  POP BP
  POP DS
  RET 4
OneInRAM:
  CALL GetLayerSeg
  MOV DI,CX   
  MOV BX,[BP+8]
  CALL GetLayerSeg
  MOV ES,CX   
  MOV DS,DI   
  XOR DI,DI   
  XOR SI,SI
  MOV CX,16000
  REP MOVSD
EndCopy:
  POP BP
  POP DS
  RET 4
DQBcopyLayer ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBclearLayer
DQBclearLayer PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+6]
  CALL GetLayerSeg
  MOV ES,CX
  MOV CX,16000
  XOR EAX,EAX
  XOR DI,DI
  REP STOSD
  POP BP
  RET 2
DQBclearLayer ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBwait
DQBwait PROC
  PUSH BP
  MOV BP,SP
  MOV CX,[BP+6]
  MOV DX,3DAh 
Loop1:
  IN AL,DX
  AND AL,8
  JNZ Loop1
Loop2:
  IN AL,DX
  AND AL,8
  JZ Loop2
  DEC CX
  JNZ Loop1
  POP BP
  RET 2
DQBwait ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBFPU
DQBFPU PROC
  PUSH DS
  MOV AX,CS
  MOV DS,AX
  MOV DX,OFFSET DQBINT3D
  MOV AX,253DH ;; (SET INTERRUPT VECTOR)
  INT 21H
  POP DS
  RET
DQBFPU ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBINT3D
DQBINT3D PROC
  PUSH BP
  MOV BP,SP
  PUSH DI
  PUSH ES
  LES DI,[BP+2] ;; ES:DI PTR TO RETURN ADDRESS
  MOV WORD PTR ES:[DI-2],0C089H ;; MOV AX, AX (FASTER THAN NOP, NOP)
  POP ES
  POP DI
  POP BP
  IRET
DQBINT3D ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
EPIXEL MACRO
LOCAL SkipcPixel
  CMP DX,0
  JL SkipcPixel
  CMP DX,319
  JG SkipcPixel
  CMP BX,0
  JL SkipcPixel
  CMP BX,199
  JG SkipcPixel
  MOV DI,BX
  SHL BX,8
  SHL DI,6
  ADD DI,BX
  ADD DI,DX
  MOV ES:[DI],AL
SkipcPixel:
ENDM

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
GETPIXEL MACRO
LOCAL SkipgPixel
  MOV AX,-1
  CMP BX,0
  JL SkipgPixel
  CMP BX,199
  JG SkipgPixel
  CMP DX,0
  JL SkipgPixel
  CMP DX,319
  JG SkipgPixel
  MOV DI,BX
  MOV SI,BX
  SHL SI,8
  SHL DI,6
  ADD DI,SI
  ADD DI,DX
  XOR AH,AH
  MOV AL,ES:[DI]
SkipgPixel:
ENDM

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBpset
DQBpset PROC
  PUSH BP
  MOV BP,SP
  MOV AX,[BP+10]
  CMP AX,0
  JL ExitPset
  CMP AX,319
  JG ExitPset
  MOV AX,[BP+8]
  CMP AX,0
  JL ExitPset
  CMP AX,199
  JG ExitPset
  MOV BX,[BP+12]
  CALL GetLayerSeg
  MOV ES,CX     
  MOV DI,[BP+8] 
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+10]
  MOV AL,[BP+6] 
  MOV ES:[DI],AL
ExitPset:
  POP BP
  RET 8
DQBpset ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBpoint
DQBpoint PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+10]
  CALL GetLayerSeg
  MOV ES,CX     
  MOV SI,[BP+6] 
  MOV BX,SI
  SHL SI,8
  SHL BX,6
  ADD SI,BX
  ADD SI,[BP+8]
  XOR AH,AH
  MOV AL,ES:[SI]
  POP BP
  RET 6
DQBpoint ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBline
DQBline PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+16]
  CALL GetLayerSeg
  MOV ES,CX
  MOV AX,[BP+14]
  MOV BX,[BP+10]
  CMP AX,BX
  JG Line1
  SUB BX,AX
  MOV deltax,BX
  JMP Line2
Line1:
  SUB AX,BX
  MOV deltax,AX
Line2:
  MOV AX,[BP+12]
  MOV BX,[BP+8]
  CMP AX,BX
  JG Line3
  SUB BX,AX
  MOV deltay,BX
  JMP Line4
Line3:
  SUB AX,BX
  MOV deltay,AX
Line4:
  MOV AX,deltax
  CMP AX,deltay
  JL Line5
  MOV CX,deltax
  INC CX
  MOV BX,deltay
  SHL BX,1
  MOV dinc1,BX
  SUB BX,AX
  MOV d,BX
  MOV BX,deltay
  SUB BX,AX
  SHL BX,1
  MOV dinc2,BX
  MOV xinc1,1
  MOV xinc2,1
  MOV yinc1,0
  MOV yinc2,1
  JMP Line6
Line5:
  MOV CX,deltay
  INC CX
  MOV BX,deltax
  SHL BX,1
  MOV dinc1,BX
  SUB BX,CX
  MOV d,BX
  SUB AX,CX
  INC AX
  SHL AX,1
  MOV dinc2,AX
  MOV xinc1,0
  MOV xinc2,1
  MOV yinc1,1
  MOV yinc2,1
Line6:
  MOV AX,[BP+14]
  CMP AX,[BP+10]
  JLE Line7
  NEG xinc1
  NEG xinc2
Line7:
  MOV AX,[BP+12]
  CMP AX,[BP+8]
  JLE Line8
  NEG yinc1
  NEG yinc2
Line8:
  MOV DX,[BP+14]
  MOV BX,[BP+12]
  MOV AX,[BP+6] 
LineLoop:
  CMP DX,0
  JL SkipLinePixel
  CMP DX,319
  JG SkipLinePixel
  CMP BX,0
  JL SkipLinePixel
  CMP BX,199
  JG SkipLinePixel
  MOV DI,BX
  MOV SI,BX
  SHL DI,8
  SHL SI,6
  ADD DI,SI
  ADD DI,DX
  MOV ES:[DI],AL
SkipLinePixel:
  CMP d,0
  JL Line9
  MOV SI,d
  ADD SI,dinc2
  MOV d,SI
  ADD DX,xinc2
  ADD BX,yinc2
  JMP Line10
Line9:
  MOV SI,d
  ADD SI,dinc1
  MOV d,SI
  ADD DX,xinc1
  ADD BX,yinc1
Line10:
  DEC CX
  JNZ LineLoop
  POP BP
  RET 12
DQBline ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBellipse
DQBellipse PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+16]
  CALL GetLayerSeg
  MOV ES,CX
  SUB SP,12
  MOV BP,SP
  MOV AX,[BP+22]
  CMP AX,0
  JNE NotVline
  MOV AX,[BP+18]
  MOV CX,[BP+20]
  NEG CX
eVline:
  MOV DX,[BP+26]
  MOV BX,[BP+24]
  ADD BX,CX
  EPIXEL
  INC CX
  CMP CX,[BP+20]
  JLE eVline
  JMP EndEllipse
NotVline:
  MOV AX,[BP+20]
  CMP AX,0
  JNE NotHline
  MOV AX,[BP+18]
  MOV CX,[BP+22]
  NEG CX
eHline:
  MOV DX,[BP+26]
  ADD DX,CX
  MOV BX,[BP+24]
  EPIXEL
  INC CX
  CMP CX,[BP+22]
  JLE eHline
  JMP EndEllipse
NotHline:
  CMP AX,[BP+22]
  JG OtherAxis
  XOR AX,AX
  MOV [BP+10],AX
  MOV [BP+6],AX
  MOV AX,[BP+20]
  MOV [BP+8],AX
  MOV AX,[BP+22]
  MOV BX,AX
  MUL BX
  MOV [BP+4],AX
  PUSH AX
  SHR AX,1
  NEG AX
  MOV [BP+2],AX
  POP AX
  XOR DX,DX
  MOV BX,[BP+20]
  DIV BX
  MOV [BP],AX
  MOV AX,[BP+18]
Circle1:
  MOV CX,[BP+2]
  CMP CX,0
  JG Circle3
Circle2:
  MOV DX,[BP+26]
  ADD DX,[BP+10]
  MOV BX,[BP+24]
  ADD BX,[BP+8]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+10]
  MOV BX,[BP+24]
  ADD BX,[BP+8]
  EPIXEL
  MOV DX,[BP+26]
  ADD DX,[BP+10]
  MOV BX,[BP+24]
  SUB BX,[BP+8]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+10]
  MOV BX,[BP+24]
  SUB BX,[BP+8]
  EPIXEL
  MOV BX,[BP+10]
  INC BX
  MOV [BP+10],BX
  MOV BX,[BP+6]
  ADD BX,[BP+20]
  MOV [BP+6],BX
  MOV BX,[BP+2]
  ADD BX,[BP+6]
  MOV [BP+2],BX
  CMP BX,0
  JLE Circle2
  JMP Circle4
Circle3:
  MOV DX,[BP+26]
  ADD DX,[BP+10]
  MOV BX,[BP+24]
  ADD BX,[BP+8]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+10]
  MOV BX,[BP+24]
  ADD BX,[BP+8]
  EPIXEL
  MOV DX,[BP+26]
  ADD DX,[BP+10]
  MOV BX,[BP+24]
  SUB BX,[BP+8]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+10]
  MOV BX,[BP+24]
  SUB BX,[BP+8]
  EPIXEL
Circle4:
  MOV BX,[BP+4]
  SUB BX,[BP]
  MOV [BP+4],BX
  MOV BX,[BP+2]
  SUB BX,[BP+4]
  MOV [BP+2],BX
  MOV BX,[BP+8]
  DEC BX
  MOV [BP+8],BX
  CMP BX,0
  JNZ Circle1
  MOV DX,[BP+26]
  ADD DX,[BP+10]
  MOV BX,[BP+24]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+10]
  MOV BX,[BP+24]
  EPIXEL
  JMP EndEllipse
OtherAxis:
  XOR AX,AX
  MOV [BP+10],AX
  MOV [BP+6],AX
  MOV AX,[BP+22]
  MOV [BP+8],AX
  MOV AX,[BP+20]
  MOV BX,AX
  MUL BX
  MOV [BP+4],AX
  PUSH AX
  SHR AX,1
  NEG AX
  MOV [BP+2],AX
  POP AX
  XOR DX,DX
  MOV BX,[BP+22]
  DIV BX
  MOV [BP],AX
  MOV AX,[BP+18]
Circle5:
  MOV CX,[BP+2]
  CMP CX,0
  JG Circle7
Circle6:
  MOV DX,[BP+26]
  ADD DX,[BP+8]
  MOV BX,[BP+24]
  ADD BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+8]
  MOV BX,[BP+24]
  ADD BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  ADD DX,[BP+8]
  MOV BX,[BP+24]
  SUB BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+8]
  MOV BX,[BP+24]
  SUB BX,[BP+10]
  EPIXEL
  MOV BX,[BP+10]
  INC BX
  MOV [BP+10],BX
  MOV BX,[BP+6]
  ADD BX,[BP+22]
  MOV [BP+6],BX
  MOV BX,[BP+2]
  ADD BX,[BP+6]
  MOV [BP+2],BX
  CMP BX,0
  JLE Circle6
  JMP Circle8
Circle7:
  MOV DX,[BP+26]
  ADD DX,[BP+8]
  MOV BX,[BP+24]
  ADD BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+8]
  MOV BX,[BP+24]
  ADD BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  ADD DX,[BP+8]
  MOV BX,[BP+24]
  SUB BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  SUB DX,[BP+8]
  MOV BX,[BP+24]
  SUB BX,[BP+10]
  EPIXEL
Circle8:
  MOV BX,[BP+4]
  SUB BX,[BP]
  MOV [BP+4],BX
  MOV BX,[BP+2]
  SUB BX,[BP+4]
  MOV [BP+2],BX
  MOV BX,[BP+8]
  DEC BX
  MOV [BP+8],BX
  CMP BX,0
  JNZ Circle5
  MOV DX,[BP+26]
  MOV BX,[BP+24]
  ADD BX,[BP+10]
  EPIXEL
  MOV DX,[BP+26]
  MOV BX,[BP+24]
  SUB BX,[BP+10]
  EPIXEL
EndEllipse:
  ADD SP,12
  POP BP
  RET 12
DQBellipse ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBbox
DQBbox PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+16]
  CALL GetLayerSeg
  MOV ES,CX
  MOV DI,[BP+12]
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+14]
  MOV CX,[BP+10]
  SUB CX,[BP+14]
  INC CX
  MOV AL,[BP+6]
  MOV AH,AL
  MOV DX,CX
  PUSH CX
  CMP CX,2
  JL BoxByteTest1
  SHR CX,1
  REP STOSW
BoxByteTest1:
  TEST DX,1
  JZ DrawBorders
  STOSB
DrawBorders:
  POP DX
  SUB DX,2
  MOV DI,[BP+12]
  INC DI
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+14]
  MOV CX,[BP+8]
  SUB CX,[BP+12]
  DEC CX
  PUSH CX
  CMP CX,0
  JLE LowerBorder
BorderLoop:
  STOSB
  ADD DI,DX
  STOSB
  ADD DI,318
  SUB DI,DX
  DEC CX
  JNZ BorderLoop
LowerBorder:
  POP CX
  CMP CX,0
  JL EndBox
  MOV CX,[BP+10]
  SUB CX,[BP+14]
  INC CX
  MOV DX,CX
  CMP CX,2
  JL BoxByteTest2
  SHR CX,1
  REP STOSW
BoxByteTest2:
  TEST DX,1
  JZ EndBox
  STOSB
EndBox:
  POP BP
  RET 12
DQBbox ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBboxf
DQBboxf PROC
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+16]
  CALL GetLayerSeg
  MOV ES,CX
  MOV DI,[BP+12]
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+14]
  MOV CX,[BP+10]
  SUB CX,[BP+14]
  INC CX
  MOV DX,[BP+8]
  SUB DX,[BP+12]
  INC DX
  MOV AL,[BP+6]
  MOV AH,AL
BoxfLoop:
  PUSH CX
  SHR CX,1
  CMP CX,0
  JE BoxfByteTest
  REP STOSW
BoxfByteTest:
  POP CX
  TEST CX,1
  JZ NextBoxfLine
  STOSB
NextBoxfLine:
  ADD DI,320
  SUB DI,CX
  DEC DX
  JNZ BoxfLoop
  POP BP
  RET 12
DQBboxf ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBscroll
DQBscroll PROC
  PUSH BP
  PUSH DS
  MOV BP,SP
  MOV BX,[BP+12]
  CALL GetLayerSeg
  MOV DS,CX   
  MOV ES,CX     
  MOV SI,[BP+10]
  MOV AX,[BP+8] 
  MOV BX,320
  IMUL BX
  ADD AX,SI
  OR AX,AX
  JNS Positive
  NEG AX
  MOV CX,64000
  SUB CX,AX
  MOV SI,AX
  XOR DI,DI
  CLD
  REP MOVSB
  POP DS
  POP BP
  RET 6
Positive:
  MOV CX,64000
  SUB CX,AX
  MOV SI,63999
  SUB SI,AX
  MOV DI,63999
  STD
  REP MOVSB
  CLD
  POP DS
  POP BP
  RET 6
DQBscroll ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBsetTransPut
DQBsetTransPut PROC
  MOV PutMode,0
  RET
DQBsetTransPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBsetSolidPut
DQBsetSolidPut PROC
  MOV PutMode,1
  RET
DQBsetSolidPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBget
DQBget PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV AX,[BP+14]
  SUB AX,[BP+18]
  INC AX          
  MOV BX,[BP+12]
  SUB BX,[BP+16]
  INC BX          
  PUSH BX         
  PUSH AX         
  MOV BP,SP       
  MOV BX,[BP+24]
  CALL GetLayerSeg
  MOV DS,CX       
  MOV SI,[BP+20]
  MOV BX,SI
  SHL SI,8
  SHL BX,6
  ADD SI,BX
  ADD SI,[BP+22]  
  MOV BX,[BP+14]
  MOV ES,BX
  MOV DI,[BP+12]  
  MOV DX,[BP+2]   
  MOV BX,[BP]     
  SHL BX,3        
  MOV ES:[DI],BX  
  MOV ES:[DI+2],DX
  ADD DI,4
  MOV BX,[BP]
  AND BX,3
  CMP BX,0
  JE DWordGetLoop 
  MOV BX,[BP]
  AND BX,1
  CMP BX,0
  JE WordGetLoop  
ByteGetLoop:
  MOV CX,[BP]     
  REP MOVSB       
  SUB SI,[BP]
  ADD SI,320
  DEC DX
  JNZ ByteGetLoop
  JMP EndGet
WordGetLoop:
  MOV CX,[BP]
  SHR CX,1
  REP MOVSW       
  SUB SI,[BP]
  ADD SI,320
  DEC DX
  JNZ WordGetLoop
  JMP EndGet
DWordGetLoop:
  MOV CX,[BP]
  SHR CX,2
  REP MOVSD       
  SUB SI,[BP]
  ADD SI,320
  DEC DX
  JNZ DWordGetLoop
EndGet:
  POP BX
  POP BX
  POP BP
  POP DS
  RET 14
DQBget ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU


EVEN
PUBLIC DQBput
DQBput PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV SI,[BP+08]    
  MOV BX,[BP+16]    
  CALL GetLayerSeg
  MOV ES,CX         
  MOV DI,[BP+12]    
  DEC DI
  MOV AX,PutMode    
  PUSH AX           
  MOV AX,0
  PUSH AX
  MOV AX,319
  PUSH AX
  MOV AX,0
  PUSH AX
  MOV AX,199
  PUSH AX
  MOV BX,[BP+10]
  MOV DS,BX         
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+14]    
  LODSW
  SHR AX,3          
  PUSH AX           
  LODSW        
  MOV AH,AL         
  INC AH
  XOR AL,AL
  MOV BP,SP
  MOV BX,[BP+24]    
  DEC BX
  ADD DI,[BP]
  CMP [BP+10],AL    
  JNE SolidYloop    
Yloop:
  ADD SI,[BP]
  ADD DI,320        
  INC BX            
  DEC AH
  JZ EndPut         
  CMP BX,[BP+4]     
  JL Yloop          
  CMP BX,[BP+2]     
  JG EndPut         
  SUB DI,[BP]       
  SUB SI,[BP]
  MOV DX,[BP+26]    
  MOV CX,[BP]       
Xloop:
  LODSB             
  CMP AL,0
  JE SkipPixel      
  CMP DX,[BP+8]
  JL SkipPixel      
  CMP DX,[BP+6]
  JG SkipPixel      
  STOSB             
  INC DX            
  LOOP Xloop        
  JMP Yloop         
SkipPixel:
  INC DI            
  INC DX            
  LOOP Xloop        
  JMP Yloop         
SolidYloop:
  ADD SI,[BP]
  ADD DI,320        
  INC BX            
  DEC AH
  JZ EndPut         
  CMP BX,[BP+4]     
  JL SolidYloop     
  CMP BX,[BP+2]     
  JG EndPut         
  SUB DI,[BP]       
  SUB SI,[BP]
  MOV DX,[BP+26]    
  MOV CX,[BP]       
SolidXloop:
  LODSB             
  CMP DX,[BP+8]
  JL SkipSolidPixel 
  CMP DX,[BP+6]
  JG SkipSolidPixel 
  STOSB             
  INC DX            
  LOOP SolidXloop  
  JMP SolidYloop   
SkipSolidPixel:
  INC DI           
  INC DX           
  LOOP SolidXloop  
  JMP SolidYloop   
EndPut:
  POP BX
  POP BX
  POP BX
  POP BX
  POP BX
  POP BX
  POP BP
  POP DS
  RET 10
DQBput ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU DQBcPut by James Robert Osborne

EVEN
PUBLIC DQBcPut        
DQBcPut PROC          
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+16]         
  CALL GetLayerSeg    
  MOV ES,CX
  MOV BX,[BP+12] 
  MOV DI,BX      
  SHL DI, 8      
  SHL BX, 6      
  ADD DI, BX     
  ADD DI,[BP+14] 
  MOV DS,[BP+10] 
  MOV SI,[BP+8]  
  ADD SI, 4      
  MOV DX, 16
  MOV BX, DX
  MOV CX, BX
 LoopStart:
  LODSB
  TEST AL, AL
  JE SHORT @F
  MOV ES:[DI], AL
 @@:
  INC DI
  LOOP LoopStart
  ADD DI, 304
  MOV CX, DX
  DEC BX
  JNZ LoopStart
  POP BP
  POP DS
  RET 10
DQBcPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU DQBbtPut by James Robert Osborne

EVEN
PUBLIC DQBbtPut        
DQBbtPut PROC          
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+8]
  MOV FS,BX
  MOV BX,[BP+18]         
  CALL GetLayerSeg    
  MOV ES,CX
  MOV BX,[BP+14] 
  MOV DI,BX      
  SHL DI, 8      
  SHL BX, 6      
  ADD DI, BX     
  ADD DI,[BP+16] 
  MOV DS,[BP+12]
  MOV SI,[BP+10]
  ADD SI, 4
  MOV CX, 16
  MOV AH, CL
 LoopStart2:
  LODSB
  TEST AL, AL
  JE SkipPix
  CMP AL, 129
  JL SolidPix
  CMP AL, 136
  JG SolidPix
  XOR BX, BX
  MOV BL, AL
  SUB BX, 129
  SHL BX, 8
  MOV AL,ES:[DI]
  ADD BL, AL
  MOV DX, SI
  MOV SI, BX
  MOV AL,FS:[SI]
  MOV SI, DX
 SolidPix:
  MOV ES:[DI],AL
 SkipPix:
  INC DI
  LOOP LoopStart2
  ADD DI, 304
  MOV CX, 16
  DEC AH
  JNZ LoopStart2
  POP BP
  POP DS
  RET 12
DQBbtPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBrPut
DQBrPut PROC
  PUSH DS
  PUSH BP
  MOV AX,PutMode
  PUSH AX
  MOV AX,0
  PUSH AX
  MOV AX,319
  PUSH AX
  MOV AX,0
  PUSH AX
  MOV AX,199
  PUSH AX
  SUB SP,16
  MOV BP,SP
  MOV BX,[BP+46]
  CALL GetLayerSeg
  MOV ES,CX
  MOV DI,[BP+42]
  MOV SI,DI
  SHL DI,8
  SHL SI,6
  ADD DI,SI
  ADD DI,[BP+44]
  MOV AX,[BP+36]
  ADD AX,64
  XOR AH,AH
  MOV SI,AX
  SHL SI,1
  MOV AX,SinTable[SI]
  MOV BX,100
  IMUL BX
  SHL EDX,16
  MOV DX,AX
  MOV EAX,EDX
  CDQ
  XOR ESI,ESI
  MOV SI,[BP+34]
  IDIV ESI
  MOV [BP+4],EAX
  MOV AX,[BP+36]
  XOR AH,AH
  MOV SI,AX
  SHL SI,1
  MOV AX,SinTable[SI]
  IMUL BX
  SHL EDX,16
  MOV DX,AX
  MOV EAX,EDX
  CDQ
  XOR ESI,ESI
  MOV SI,[BP+34]
  IDIV ESI
  MOV [BP],EAX
  MOV AX,[BP+40]
  MOV DS,AX
  MOV SI,[BP+38]
  XOR EAX,EAX
  LODSW
  SHR AX,3
  MOV [BP+14],AX
  SHR AX,1
  MOV [BP+10],AX
  LODSW
  MOV [BP+12],AX
  SHR AX,1
  MOV [BP+8],AX
  MOV EDX,[BP]
  IMUL EDX
  MOV ESI,EAX
  NEG ESI
  XOR EAX,EAX
  MOV AX,256
  MOV DX,[BP+8]
  MUL DX
  ADD ESI,EAX
  XOR EAX,EAX
  MOV AX,[BP+10]
  MOV EDX,[BP+4]
  IMUL EDX
  SUB ESI,EAX
  XOR EAX,EAX
  MOV AX,[BP+10]
  MOV EDX,[BP]
  IMUL EDX
  MOV EBX,EAX
  NEG EBX
  XOR EAX,EAX
  MOV AX,256
  MOV DX,[BP+10]
  MUL DX
  ADD EBX,EAX
  XOR EAX,EAX
  MOV AX,[BP+8]
  MOV EDX,[BP+4]
  IMUL EDX
  ADD EAX,EBX
  XOR CX,CX
RotYloop:
  PUSH CX
  PUSH EAX
  PUSH ESI
  ADD DI,[BP+14]
  ADD CX,[BP+42]
  CMP CX,[BP+18]
  JL RotSkipLine
  CMP CX,[BP+16]
  JG RotSkipLine
  SUB DI,[BP+14]
  XOR CX,CX
RotXloop:
  PUSH CX
  ADD CX,[BP+44]
  CMP CX,[BP+22]
  JL RotSkip
  CMP CX,[BP+20]
  JG RotSkip
  MOV EBX,EAX
  SHR EBX,8
  MOV EDX,ESI
  SHR EDX,8
  CMP DX,0
  JL RotSkip
  CMP DX,[BP+12]
  JGE RotSkip
  CMP BX,0
  JL RotSkip
  CMP BX,[BP+14]
  JGE RotSkip
  PUSH EAX
  PUSH EDX
  MOV AX,[BP+14]
  MUL DX
  ADD BX,AX
  ADD BX,[BP+38]
  MOV BL,DS:[BX+4]
  MOV AX,[BP+24]
  CMP AX,0
  JNE SkipTest
  CMP BL,0
  JE RotSkip0
SkipTest:
  MOV ES:[DI],BL
RotSkip0:
  POP EDX
  POP EAX
RotSkip:
  POP CX
  ADD EAX,[BP]
  ADD ESI,[BP+4]
  INC DI
  INC CX
  CMP CX,[BP+14]
  JL RotXloop
RotSkipLine:
  ADD DI,320
  SUB DI,[BP+14]
  POP ESI
  POP EAX
  SUB EAX,[BP+4]
  ADD ESI,[BP]
  POP CX
  INC CX
  CMP CX,[BP+12]
  JL RotYloop
  ADD SP,26
  POP BP
  POP DS
  RET 14
DQBrPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBsPut
DQBsPut PROC
  PUSH DS
  PUSH BP
  MOV AX,PutMode
  PUSH AX
  MOV AX,0
  PUSH AX
  MOV AX,319
  PUSH AX
  MOV AX,0
  PUSH AX
  MOV AX,199
  PUSH AX
  SUB SP,6  
  MOV BP,SP
  MOV BX,[BP+36]
  CALL GetLayerSeg
  MOV ES,CX
  MOV AX,[BP+30]
  MOV DS,AX
  MOV SI,[BP+28]
  MOV AX,[SI]
  SHR AX,3
  PUSH AX
  MOV AX,[SI+2]
  PUSH AX
  MOV BP,SP
  SHL AX,7       
  MOV BX,[BP+28] 
  XOR DX,DX
  DIV BX
  MOV [BP+6],AX  
  MOV AX,[BP+2]
  SHL AX,7       
  MOV BX,[BP+30]
  XOR DX,DX
  DIV BX
  MOV [BP+8],AX  
  XOR CX,CX
  MOV [BP+4],CX
  MOV SI,[BP+32]
  ADD SI,4       
  MOV AX,[BP+18]
  CMP AX,0
  JNE SolidScaledYloop
ScaledYloop:
  MOV DI,[BP+36]
  ADD DI,CX
  CMP DI,[BP+12]
  JL SkipScaledLine
  CMP DI,[BP+10]
  JG SkipScaledLine
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+38]
  PUSH CX
  XOR CX,CX
  XOR DX,DX
  XOR BX,BX
ScaledXloop:
  MOV AX,[BP+38]
  ADD AX,CX
  CMP AX,[BP+16]
  JL SkipScaledPixel
  CMP AX,[BP+14]
  JG SkipScaledPixel
  MOV AL,[SI+BX]
  CMP AL,0
  JE SkipScaledPixel
  STOSB
  ADD DX,[BP+8]
  MOV BX,DX
  SHR BX,7
  INC CX
  CMP CX,[BP+30]
  JL ScaledXloop
  POP CX
  JMP SkipScaledLine
SkipScaledPixel:
  INC DI
  ADD DX,[BP+8]
  MOV BX,DX
  SHR BX,7
  INC CX
  CMP CX,[BP+30]
  JL ScaledXloop
  POP CX
SkipScaledLine:
  MOV SI,[BP+32]
  ADD SI,4
  MOV DX,[BP+6]
  ADD [BP+4],DX
  MOV AX,[BP+4]
  SHR AX,7
  MOV BX,[BP+2]
  XOR DX,DX
  MUL BX
  ADD SI,AX
  INC CX
  CMP CX,[BP+28]
  JL ScaledYloop
  ADD SP,20
  POP BP
  POP DS
  RET 14
SolidScaledYloop:
  MOV DI,[BP+36]
  ADD DI,CX
  CMP DI,[BP+12]
  JL SolidSkipScaledLine
  CMP DI,[BP+10]
  JG SolidSkipScaledLine
  MOV BX,DI
  SHL DI,8
  SHL BX,6
  ADD DI,BX
  ADD DI,[BP+38]
  PUSH CX
  XOR CX,CX
  XOR DX,DX
  XOR BX,BX
SolidScaledXloop:
  MOV AX,[BP+38]
  ADD AX,CX
  CMP AX,[BP+16]
  JL SolidSkipScaledPixel
  CMP AX,[BP+14]
  JG SolidSkipScaledPixel
  MOV AL,[SI+BX]
  STOSB
  ADD DX,[BP+8]
  MOV BX,DX
  SHR BX,7
  INC CX
  CMP CX,[BP+30]
  JL SolidScaledXloop
  POP CX
  JMP SolidSkipScaledLine
SolidSkipScaledPixel:
  INC DI
  ADD DX,[BP+8]
  MOV BX,DX
  SHR BX,7
  INC CX
  CMP CX,[BP+30]
  JL SolidScaledXloop
  POP CX
SolidSkipScaledLine:
  MOV SI,[BP+32]
  ADD SI,4
  MOV DX,[BP+6]
  ADD [BP+4],DX
  MOV AX,[BP+4]
  SHR AX,7
  MOV BX,[BP+2]
  XOR DX,DX
  MUL BX
  ADD SI,AX
  INC CX
  CMP CX,[BP+28]
  JL SolidScaledYloop
  ADD SP,20
  POP BP
  POP DS
  RET 14
DQBsPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBfPut
DQBfPut PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  MOV BX,[BP+16]
  CALL GetLayerSeg
  MOV ES,CX
  MOV DI,[BP+12]
  MOV AX,DI
  SHL AX,8
  SHL DI,6
  ADD DI,AX
  ADD DI,[BP+14]
  MOV AX,[BP+10]
  MOV DS,AX
  MOV SI,[BP+8]
  LODSW
  MOV DX,AX
  SHR DX,3    
  MOV BX,320
  SUB BX,DX   
  LODSW
  MOV CX,AX   
  TEST DX,2
  JNZ FastWordCopy
  TEST DX,1
  JNZ BYTEloop
  SHR DX,2
DWORDloop:
  PUSH CX
  MOV CX,DX
  REP MOVSD
  POP CX
  ADD DI,BX
  DEC CX
  JNZ DWORDloop
  POP BP
  POP DS
  RET 10
FastWordCopy:
  TEST DX,1
  JNZ BYTEloop
  SHR DX,1
WORDloop:
  PUSH CX
  MOV CX,DX
  REP MOVSW
  POP CX
  ADD DI,BX
  DEC CX
  JNZ WORDloop
  POP BP
  POP DS
  RET 10
BYTEloop:
  PUSH CX
  MOV CX,DX
  REP MOVSB
  POP CX
  ADD DI,BX
  DEC CX
  JNZ BYTEloop
  POP BP
  POP DS
  RET 10
DQBfPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBxPut
DQBxPut PROC
  PUSH DS
  PUSH BP
  MOV AX,PutMode 
  PUSH AX        
  MOV AX,0
  PUSH AX
  MOV AX,319
  PUSH AX
  MOV AX,0
  PUSH AX
  MOV AX,199
  PUSH AX
  MOV AX,EMSseg
  PUSH AX
  MOV AX,EMShdl
  PUSH AX
  PUSH AX
  MOV BP,SP
  MOV DI,[BP+24]
  MOV AX,DI
  SHL DI,8
  SHL AX,6
  ADD DI,AX
  ADD DI,[BP+26]
  MOV BX,[BP+28]
  CMP BX,0
  JG dNotVideo
  OR BX,BX
  JZ dOnVideo
  AND BX,0111111111111111b
  SHL BX,1
  MOV AX,BaseLayer[BX]
  MOV ES,AX
  JMP DestFixed
dOnVideo:
  MOV AX,0A000h
  MOV ES,AX
  JMP DestFixed
dNotVideo:
  MOV AX,[BP+4]
  MOV ES,AX
  XOR AX,AX
  MOV DX,[BP+24]
  OR DX,DX
  JS PageOk2
  JNZ @F
  MOV DX,[BP+26]
  OR DX,DX
  JS PageOk2
@@:
  MOV AX,DI
  SHR AX,14
  CMP AX,3
  JL PageOk2
  MOV AX,2
PageOk2:
  DEC BX
  SHL BX,2
  ADD BX,AX
  SHL AX,14
  SUB DI,AX
  ADD DI,08000h
  MOV DX,[BP+2]
  MOV AX,04402h
  INT 67h
  INC BX
  MOV AX,04403h
  INT 67h
DestFixed:
  MOV SI,[BP+34]
  MOV AX,SI
  SHL SI,8
  SHL AX,6
  ADD SI,AX
  ADD SI,[BP+36]
  MOV BX,[BP+38]
  CMP BX,[BP+28]
  JE EndXput
  CMP BX,0
  JG sNotVideo
  OR BX,BX
  JZ sOnVideo
  AND BX,0111111111111111b
  SHL BX,1
  MOV AX,BaseLayer[BX]
  MOV DS,AX
  JMP SourceFixed
sOnVideo:
  MOV AX,0A000h
  MOV DS,AX
  JMP SourceFixed
sNotVideo:
  MOV AX,[BP+4]
  MOV DS,AX
  MOV AX,SI
  SHR AX,14
  CMP AX,3
  JL PageOk1
  MOV AX,2
PageOk1:
  DEC BX
  SHL BX,2
  ADD BX,AX       
  SHL AX,14
  SUB SI,AX       
  MOV DX,[BP+2]
  MOV AX,04400h
  INT 67h
  INC BX
  MOV AX,04401h
  INT 67h
SourceFixed:
  MOV AX,[BP+32]
  SUB AX,[BP+36]
  INC AX
  MOV [BP],AX
  MOV AX,[BP+30]
  SUB AX,[BP+34]
  MOV AH,AL 
  ADD AH,2
  XOR AL,AL
  MOV BX,[BP+24] 
  DEC BX
  SUB DI,320
  SUB SI,320
  ADD DI,[BP]
  ADD SI,[BP]
  CMP [BP+14],AL 
  JNE xSolidYloop  
xYloop:
  ADD SI,320
  ADD DI,320       
  INC BX           
  DEC AH
  JZ EndXput       
  CMP BX,[BP+8]    
  JL xYloop        
  CMP BX,[BP+6]    
  JG EndXput       
  SUB DI,[BP]      
  SUB SI,[BP]
  MOV DX,[BP+26]   
  MOV CX,[BP]      
xXloop:
  LODSB            
  CMP AL,0
  JE xSkipPixel    
  CMP DX,[BP+12]
  JL xSkipPixel    
  CMP DX,[BP+10]
  JG xSkipPixel    
  MOV ES:[DI],AL
xSkipPixel:
  INC DI           
  INC DX           
  DEC CX
  JNZ xXloop       
  JMP xYloop       
xSolidYloop:
  ADD SI,320
  ADD DI,320       
  INC BX           
  DEC AH
  JZ EndXput       
  CMP BX,[BP+8]    
  JL xSolidYloop   
  CMP BX,[BP+6]    
  JG EndXput       
  SUB DI,[BP]      
  SUB SI,[BP]
  MOV DX,[BP+26]   
  MOV CX,[BP]      
xSolidXloop:
  LODSB            
  CMP DX,[BP+12]
  JL xSkipSolidPixel
  CMP DX,[BP+10]
  JG xSkipSolidPixel
  MOV ES:[DI],AL
xSkipSolidPixel:
  INC DI            
  INC DX            
  DEC CX
  JNZ xSolidXloop  
  JMP xSolidYloop  
EndXput:
  ADD SP,16        
  POP BP
  POP DS
  MOV EMSpage,-1
  RET 16
DQBxPut ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC xDQBloadImage
xDQBloadImage PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  CALL HookInt24
  MOV BX,[BP+24]
  CALL GetLayerSeg
  MOV ES,CX
  MOV AX,[BP+18]
  MOV DS,AX
  MOV DX,[BP+16]
  MOV AX,3D00h
  INT 21h
  JC Error_Open
  MOV BX,AX
  MOV AX,@DATA
  MOV DS,AX
  MOV DI,[BP+20]
  MOV AX,DI
  SHL DI,8
  SHL AX,6
  ADD DI,AX
  ADD DI,[BP+22]
  CALL ReadBuffer
  JC Error_Read
  MOV CX,10
  MOV AH,03Fh
  MOV DX,OFFSET BSVheader
  INT 21h
  JC Error_Read
  CMP BSVheader.SourceSeg,0A000h
  JNE SourceNotVideo
  MOV AX,320
  MOV SI,[BP+10]
  MOV [SI],AX
  MOV AX,200
  MOV SI,[BP+8]
  MOV [SI],AX
  MOV AX,BSVheader.BSVxSize
  MOV ES:[DI],AX
  MOV AX,BSVheader.BSVySize
  MOV ES:[DI+2],AX
  ADD DI,4
  MOV CX,BSVheader.BSVlen
  PUSH DS
  MOV AX,ES
  MOV DS,AX
  MOV AH,03Fh
  MOV DX,DI
  INT 21h
  POP DS
  JC Error_Read
  JMP CheckBSVpal
SourceNotVideo:
  SHR BSVheader.BSVxSize,3
  MOV AX,BSVheader.BSVxSize
  MOV SI,[BP+10]
  MOV [SI],AX
  MOV CX,BSVheader.BSVySize
  MOV SI,[BP+8]
  MOV [SI],CX
@@:
  PUSH DS
  PUSH CX
  MOV CX,BSVheader.BSVxSize
  MOV AX,ES
  MOV DS,AX
  MOV AH,03Fh
  MOV DX,DI
  INT 21h
  POP CX
  POP DS
  JC Error_Read
  ADD DI,320
  DEC CX
  JNZ @B
CheckBSVpal:
  MOV AX,04202h
  XOR CX,CX
  XOR DX,DX
  INT 21h
  JC Error_Read
  MOV DX,BSVheader.BSVlen
  ADD DX,7
  CMP AX,DX
  JE LoadCloseFile
  XOR CX,CX
  MOV AX,04200h
  INT 21h
  JC Error_Read
  MOV AX,[BP+14]
  MOV DS,AX
  MOV CX,768
  MOV DX,[BP+12]
  MOV AH,03Fh
  INT 21h
  JC Error_Read
  JMP LoadCloseFile
Error_Open:
  MOV AX,1  
  MOV LastError,4
  JMP EndLoadLayer
Error_Read:
  MOV AH,3Eh
  INT 21h
  MOV AX,2  
  MOV LastError,5
  JMP EndLoadLayer
Error_BadFile:
  MOV AH,3Eh
  INT 21h
  MOV AX,3  
  MOV LastError,11
  JMP EndLoadLayer
LoadCloseFile:
  MOV AH,3Eh
  INT 21h
  XOR AX,AX
EndLoadLayer:
  CALL UnhookInt24
  POP BP
  POP DS
  RET 18
xDQBloadImage ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
WAITWRITEDSP MACRO
LOCAL WaitWrite,EndWriteDSP
  PUSH CX
  XOR CX,CX
WaitWrite:
  DEC CX
  JZ EndWriteDSP
  IN AL,DX
  OR AL,AL
  JS WaitWrite
EndWriteDSP:
  POP CX
ENDM

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
WAITREADDSP MACRO
LOCAL WaitRead,EndReadDSP
  PUSH CX
  XOR CX,CX
WaitRead:
  DEC CX
  JZ EndReadDSP
  IN AL,DX
  OR AL,AL
  JNS WaitRead
EndReadDSP:
  POP CX
ENDM

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
SETUPDMA MACRO
LOCAL NoOverRide
  MOV SI,OFFSET SoundBuffer
  MOV CX,(BUFFERLEN-1)
  MOV AX,@DATA
  ROL AX,4
  MOV BL,AL
  AND BL,00Fh
  AND AL,0F0h
  ADD SI,AX
  ADC BL,0
  NEG SI
  CMP SI,CX
  JA NoOverRide
  NEG SI
  ADD SI,CX
  INC SI
  INC BL
  NEG SI
NoOverRide:
  NEG SI
  MOV AL,DMA
  ADD AL,4
  OUT 0Ah,AL
  OUT 0Ch,AL
  MOV AL,058h
  ADD AL,DMA
  OUT 0Bh,AL
  MOV AL,BL
  MOV DX,DMA_Page
  OUT DX,AL
  MOV AX,SI
  MOV DX,DMA_Base
  OUT DX,AL
  MOV AL,AH
  OUT DX,AL
  MOV AL,CL
  MOV DX,DMA_Count
  OUT DX,AL
  MOV AL,CH
  OUT DX,AL
  MOV AL,DMA
  OUT 0Ah,AL
  MOV DX,BaseAddr
  ADD DX,0Ch
  PUSH DX
  MOV AX,1000
  MUL AX
  MOV BX,SamplingRate
  DIV BX
  NEG AL
  MOV AH,AL
  POP DX
  WAITWRITEDSP
  MOV AL,040h
  OUT DX,AL
  WAITWRITEDSP
  MOV AL,AH
  OUT DX,AL
  WAITWRITEDSP
  MOV AL,048h
  OUT DX,AL
  MOV CX,((BUFFERLEN/2)-1)
  WAITWRITEDSP
  MOV AL,CL
  OUT DX,AL
  WAITWRITEDSP
  MOV AL,CH
  OUT DX,AL
  WAITWRITEDSP
  MOV AL,01Ch
  OUT DX,AL
ENDM

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
MIXVOICES MACRO
LOCAL MixSample,MapPage2,MixIt,LoopThis,DontLoop,MixDone,ClipSample
  CLD
  MOV AX,VolSeg
  MOV FS,AX
  MOV DI,OFFSET MixBuffer
  MOV CX,(BUFFERLEN/4)
  XOR EAX,EAX
  REP STOSD
  CMP Playing,0 
  JE MixDone
  MOV AX,EMSseg
  MOV ES,AX
  MOV SI,-2
MixSample:
  ADD SI,2
  MOV CX,SI
  SHR CX,1
  CMP CX,Channels
  JGE MixDone
  CMP VoiceSound[SI],0
  JE MixSample
  MOV BX,VoiceSound[SI]
  DEC BX
  SHL BX,2
  ADD BX,SoundPage
  MOV DX,EMShdl
  MOV AX,04400h 
  INT 67h       
  INC BX        
  MOV AX,04401h
  INT 67h
  INC BX
  MOV AX,04402h
  INT 67h
  INC BX
  MOV AX,04403h
  INT 67h
  MOV DX,VoiceLoopEnd[SI]
  XOR CX,CX
  XOR DI,DI
MixIt:
  MOV BX,LowCount[SI]
  ADD Counter[SI],BX 
  MOV BX,SamplePtr[SI]
  ADC BX,HighCount[SI]
  CMP BX,DX           
  JB DontLoop         
  CMP VoiceLoop[SI],1 
  JE LoopThis         
  MOV VoiceSound[SI],0
  DEC Playing         
  JMP MixSample
LoopThis:
  SUB BX,VoiceLoopLen[SI]
DontLoop:
  MOV SamplePtr[SI],BX   
  XOR AH,AH
  MOV AL,ES:[BX] 
  CMP VolActive,0
  JE @F
  MOV BX,AX
  SHL BX,6        
  ADD BX,VoiceVol[SI]
  MOV AL,FS:[BX]  
@@:
  SUB AX,080h           
  ADD MixBuffer[DI],AX  
  ADD DI,2
  INC CX
  CMP CX,(BUFFERLEN/2)  
  JB MixIt
  JMP MixSample
MixDone:
  MOV AX,@DATA
  MOV ES,AX
  MOV SI,OFFSET MixBuffer
  MOV DI,OFFSET SoundBuffer
  ADD DI,MixPtr
  MOV CX,(BUFFERLEN/2)  
ClipSample:  
  LODSW          
  ADD AX,080h    
  CMP AX,255     
  JLE @F         
  OR AX,0FFh
@@:
  CMP AX,0
  JGE @F         
  XOR AX,AX
@@:
  STOSB
  DEC CX
  JNZ ClipSample
  XOR MixPtr,(BUFFERLEN/2)
ENDM

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBinstallSB
DQBinstallSB PROC
  PUSH BP
  MOV BP,SP
  CMP EMSallocated,0
  JG CheckSounds
  MOV AX,1       
  MOV LastError,12
  POP BP
  RET 12
CheckSounds:
  CMP NumSounds,0
  JG InstallSB
  MOV AX,1       
  MOV LastError,12
  POP BP
  RET 12
InstallSB:
  CMP SoundActive,0
  JE NotInstalled
  XOR AX,AX
  POP BP
  RET 12
NotInstalled:
  MOV AH,062h
  INT 21h
  MOV ES,BX      
  MOV AX,ES:[02Ch]
  MOV ES,AX      
  MOV SI,OFFSET Blaster
  XOR DI,DI
@@:
  PUSH SI
  PUSH DI
  MOV CX,8
  REPE CMPSB     
  JE ScanA       
  POP DI
  POP SI
  INC DI
  CMP DI,1000    
  JB @B          
  JMP BLASTERdone
ScanA:
  POP DI
  POP SI
  ADD DI,8
  MOV DX,DI
  MOV SI,30
  XOR AL,AL
  MOV CX,SI
  REPNE SCASB
  JNE @F
  SUB DI,DX
  MOV SI,DI
@@:
  MOV DI,DX
  MOV AL,'A'
  MOV CX,SI      
  REPNE SCASB
  JE @F
  MOV DI,DX
  MOV AL,'a'
  MOV CX,SI
  REPNE SCASB
  JNE ScanI
@@:
  MOV AL,ES:[DI]
  SUB AL,'0'
  CBW
  SHL AX,8
  MOV BX,AX
  MOV AL,ES:[DI+1]
  SUB AL,'0'
  CBW
  SHL AX,4
  ADD BX,AX
  MOV AL,ES:[DI+2]
  SUB AL,'0'
  CBW
  ADD BX,AX
  MOV AX,[BP+10]
  CMP AX,0FFFFh
  JNE ScanI
  MOV [BP+10],BX
ScanI:
  MOV DI,DX
  MOV AL,'I'
  MOV CX,SI
  REPNE SCASB
  JE @F
  MOV DI,DX
  MOV AL,'i'
  MOV CX,SI
  REPNE SCASB
  JNE ScanD
@@:
  MOV AL,ES:[DI]
  SUB AL,'0'
  XOR AH,AH
  MOV BX,[BP+8]
  CMP BX,0FFFFh
  JNE ScanD
  MOV [BP+8],AX
ScanD:
  MOV DI,DX
  MOV AL,'D'
  MOV CX,SI
  REPNE SCASB
  JE @F
  MOV DI,DX
  MOV AL,'d'
  MOV CX,SI
  REPNE SCASB
  JNE BLASTERdone
@@:
  MOV AL,ES:[DI]
  SUB AL,'0'
  XOR AH,AH
  MOV BX,[BP+6]
  CMP BX,0FFFFh
  JNE BLASTERdone
  MOV [BP+6],AX
BLASTERdone:
  MOV AX,[BP+10]
  CMP AX,0FFFFh
  JE Error_BLASTER
  MOV AX,[BP+8]
  CMP AX,0FFFFh
  JE Error_BLASTER
  MOV AX,[BP+6]
  CMP AX,0FFFFh
  JE Error_BLASTER
  JMP SettingsOk
Error_BLASTER:
  MOV AX,5
  MOV LastError,23
  POP BP
  RET 12
SettingsOk:
  MOV VolActive,0
  MOV AX,[BP+16]
  OR AX,AX
  JZ VolumeDone
  MOV AH,48h
  MOV BX,1024
  INT 21h
  JNC MemOk
  MOV AX,7       
  MOV LastError,7
  POP BP
  RET 12
MemOk:
  MOV VolSeg,AX
  MOV ES,AX
  XOR CX,CX
  XOR DI,DI
ComputeSample:
  XOR BX,BX
ComputeVol:
  MOV AX,CX
  SUB AX,128
  IMUL BX
  MOV SI,64
  IDIV SI
  ADD AX,128
  MOV ES:[DI],AL
  INC DI
  INC BX
  CMP BX,64
  JL ComputeVol
  INC CX
  CMP CX,256
  JL ComputeSample
  MOV VolActive,1
VolumeDone:
  MOV Playing,0
  MOV AX,[BP+10]
  MOV BaseAddr,AX
  MOV CX,[BP+8]
  MOV IRQ,CL
  MOV BL,1
  SHL BL,CL
  MOV PicORmask,BL
  XOR BL,0FFh
  MOV PicANDmask,BL
  MOV AX,[BP+6]
  MOV DMA,AL
  CMP AL,0
  JNE TestDMA1
  MOV DMA_Page,087h
  MOV DMA_Base,0
  MOV DMA_Count,1
  JMP DMAdone
TestDMA1:
  CMP AL,1
  JNE TestDMA2
  MOV DMA_Page,083h
  MOV DMA_Base,2
  MOV DMA_Count,3
  JMP DMAdone
TestDMA2:
  CMP AL,2
  JNE TestDMA3
  MOV DMA_Page,081h
  MOV DMA_Base,4
  MOV DMA_Count,5
  JMP DMAdone
TestDMA3:
  CMP AL,3
  JNE DMAerror
  MOV DMA_Page,082h
  MOV DMA_Base,6
  MOV DMA_Count,7
  JMP DMAdone
DMAerror:
  MOV AX,4         
  MOV LastError,13
  POP BP
  RET 12
DMAdone:
  MOV CX,300
@@:
  MOV DX,BaseAddr
  ADD DX,06h
  MOV AL,1
  OUT DX,AL
  IN AL,DX
  IN AL,DX
  IN AL,DX
  IN AL,DX
  IN AL,DX
  IN AL,DX
  XOR AL,AL
  OUT DX,AL
  ADD DX,08h
  WAITREADDSP
  SUB DX,04h
  IN AL,DX
  CMP AL,0AAh      
  JE resetOk
  DEC CX
  JNZ @B
  MOV AX,2         
  MOV LastError,14
  POP BP
  RET 12
resetOk:           
  MOV DX,[BP+14]
  MOV Channels,DX
  MOV DX,[BP+12]
  CMP DX,23000
  JBE rateOk
  MOV AX,6         
  MOV LastError,15
  POP BP
  RET 12
rateOk:
  MOV SamplingRate,DX
  MOV DX,BaseAddr
  ADD DX,0Ch
  WAITWRITEDSP
  MOV AL,0E1h      
  OUT DX,AL
  ADD DX,2
  WAITREADDSP
  SUB DX,4
  IN AL,DX
  MOV BH,AL
  ADD DX,4
  WAITREADDSP
  SUB DX,4
  IN AL,DX
  MOV BL,AL
  CMP BX,0200h
  JGE DSPok
  MOV AX,3         
  MOV LastError,16
  POP BP
  RET 12
DSPok:
  ADD DX,2
  WAITWRITEDSP
  MOV AL,0D1h
  OUT DX,AL        
  XOR AX,AX
  MOV ES,AX
  MOV AL,IRQ
  ADD AL,8
  MOV SI,AX
  SHL SI,2
  IN AL,021h
  AND AL,PicANDmask
  OUT 021h,AL      
  MOV AX,ES:[SI]
  MOV OldIRQoff,AX
  MOV AX,OFFSET SBmix
  CLI
  MOV ES:[SI],AX
  MOV AX,ES:[SI+2]
  MOV OldIRQseg,AX
  MOV AX,SEG SBmix
  MOV ES:[SI+2],AX 
  STI
  IN AL,021h
  AND AL,PicANDmask
  OUT 021h,AL      
  SETUPDMA         
  MOV SoundActive,1
  XOR AX,AX
  POP BP
  RET 12
SBmix:
  PUSHAD
  PUSH DS
  PUSH ES
  PUSH FS
  MOV AX,@DATA
  MOV DS,AX
  MOV ES,AX
  MOV AH,47h
  MOV DX,EMShdl
  INT 67h          
  MIXVOICES        
  MOV AH,48h
  MOV DX,EMShdl
  INT 67h          
  MOV DX,BaseAddr
  ADD DX,0Eh       
  IN AL,DX
  MOV AL,20h       
  OUT 020h,AL
  POP FS
  POP ES
  POP DS
  POPAD
  IRET
DQBinstallSB ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC xDQBloadSound
xDQBloadSound PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  CALL HookInt24
  MOV AX,[BP+12]
  XOR BH,BH
  MOV BL,NumSounds
  CMP AX,BX
  JG Error_BadSlot
  MOV AX,[BP+10]
  MOV DS,AX
  MOV DX,[BP+8]
  MOV AX,03D00h
  INT 21h
  JC Error_OpenSound
  MOV BX,AX
  MOV AX,@DATA
  MOV DS,AX
  MOV CX,4
ReadRIFF:
  CALL ReadBuffer
  JC Error_ReadSound
  SHL EAX,8
  MOV AL,Buffer
  LOOP ReadRIFF
  CMP EAX,'RIFF'
  JNE Error_BadSound
  MOV CX,4
SkipRIFFlen:
  CALL ReadBuffer
  JC Error_ReadSound
  LOOP SkipRIFFlen
  MOV CX,4
ReadWAVE:
  CALL ReadBuffer
  JC Error_ReadSound
  SHL EAX,8
  MOV AL,Buffer
  LOOP ReadWAVE
  CMP EAX,'WAVE'
  JNE Error_BadSound
  MOV CX,8
SkipFmtLen:
  CALL ReadBuffer
  JC Error_ReadSound
  LOOP SkipFmtLen
  MOV CX,4
ReadFormat:
  CALL ReadBuffer
  JC Error_ReadSound
  SHL EAX,8
  MOV AL,Buffer
  LOOP ReadFormat
  CMP EAX,001000100h
  JNE Error_NotSupported
  MOV CX,4
ReadFreq:
  CALL ReadBuffer
  JC Error_ReadSound
  SHL EAX,8
  MOV AL,Buffer
  LOOP ReadFreq
  MOV DX,AX
  SHL EDX,16
  SHR EAX,16
  MOV DX,AX
  CMP EDX,23000
  JG Error_NotSupported
  MOV CX,12
SkipData:
  CALL ReadBuffer
  JC Error_ReadSound
  LOOP SkipData
  MOV CX,4
ReadLen:
  CALL ReadBuffer
  JC Error_ReadSound
  SHL EAX,8
  MOV AL,Buffer
  LOOP ReadLen
  MOV CX,4
FixLen:
  SHL EDX,8
  MOV DL,AL
  SHR EAX,8
  LOOP FixLen
  CMP EDX,0FFFFh
  JG Error_SoundTooBig
  MOV AX,DX
  MOV SI,[BP+12]
  DEC SI
  SHL SI,1
  DEC AX
  MOV SoundLen[SI],AX
  SHL SI,1
  ADD SI,SoundPage
  MOV DX,SI
  PUSH AX
  PUSH BX
  CALL MapEMS
  POP BX
  MOV AX,EMSseg
  MOV DS,AX
  XOR SI,SI
  MOV EAX,080808080h
  MOV CX,16384
ClearSound:
  MOV [SI],EAX
  ADD SI,4
  DEC CX
  JNZ ClearSound
  POP CX
  XOR DX,DX
  MOV AH,03Fh
  INT 21h
  JC Error_ReadSound
  MOV AX,03E00h
  INT 21h
  XOR AX,AX
  JMP EndLoadSound
Error_OpenSound:
  MOV AX,1         
  MOV LastError,4
  JMP EndLoadSound
Error_ReadSound:
  MOV AX,03E00h
  INT 21h
  MOV AX,2         
  MOV LastError,5
  JMP EndLoadSound
Error_BadSound:
  MOV AX,03E00h
  INT 21h
  MOV AX,3         
  MOV LastError,11
  JMP EndLoadSound
Error_NotSupported:
  MOV AX,03E00h
  INT 21h
  MOV AX,4         
  MOV LastError,17
  JMP EndLoadSound
Error_SoundTooBig:
  MOV AX,03E00h
  INT 21h
  MOV AX,5         
  MOV LastError,18
  JMP EndLoadSound
Error_BadSlot:
  MOV AX,03E00h
  INT 21h
  MOV AX,6         
  MOV LastError,19
EndLoadSound:
  CALL UnhookInt24
  POP BP
  POP DS
  RET 6
xDQBloadSound ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBplaySound
DQBplaySound PROC
  PUSH BP
  MOV BP,SP
  CMP SoundActive,0
  JE EndPlaySound
  MOV AX,[BP+12]
  XOR AH,AH
  CMP AL,NumSounds
  JG EndPlaySound
  MOV SI,[BP+10]
  DEC SI
  SHL SI,1
  CMP VoiceSound[SI],0
  JNE StillPlaying
  INC Playing
StillPlaying:
  MOV VoiceSound[SI],AX
  MOV DI,AX
  DEC DI
  SHL DI,1
  MOV AX,SoundLen[DI]
  MOV VoiceLoopEnd[SI],AX
  MOV VoiceLoopLen[SI],AX
  MOV AX,[BP+6]
  MOV VoiceLoop[SI],AX
  MOV SamplePtr[SI],0
  MOV AX,[BP+8]
  CWD
  MOV BX,SamplingRate
  DIV BX
  MOV HighCount[SI],AX
  SHL EDX,16
  MOV AX,SamplingRate
  CWDE
  MOV EBX,EAX
  MOV EAX,EDX
  CDQ
  DIV EBX
  MOV LowCount[SI],AX
  MOV Counter[SI],0
EndPlaySound:
  POP BP
  RET 8
DQBplaySound ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU
; DECLARE SUB DQBsetFreq (Channel, Frequency)   by James Robert Osborne

EVEN
PUBLIC DQBsetFreq
DQBsetFreq PROC
  PUSH BP
  MOV BP,SP
  MOV SI,[BP+8]
  DEC SI
  SHL SI,1            
  MOV AX,[BP+6]
  CWD
  MOV BX,SamplingRate
  DIV BX
  MOV HighCount[SI],AX
  SHL EDX,16
  MOV AX,SamplingRate
  CWDE
  MOV EBX,EAX
  MOV EAX,EDX
  CDQ
  DIV EBX
  MOV LowCount[SI],AX
  MOV Counter[SI],0
  POP BP
  RET 4
DQBsetFreq ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU
EVEN
PUBLIC DQBinUse
DQBinUse PROC
  PUSH BP
  MOV BP,SP
  MOV SI,[BP+6]
  DEC SI
  SHL SI,1
  XOR AX,AX
  CMP VoiceSound[SI],0
  SETNE AL
  NEG AX
  POP BP
  RET 2
DQBinUse ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBstopVoice
DQBstopVoice PROC
  PUSH BP
  MOV BP,SP
  MOV SI,[BP+6]
  DEC SI
  SHL SI,1
  CMP VoiceSound[SI],0
  JE EndStopVoice
  DEC Playing
  MOV VoiceSound[SI],0
EndStopVoice:
  POP BP
  RET 2
DQBstopVoice ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBsetVoiceVol
DQBsetVoiceVol PROC
  PUSH BP
  MOV BP,SP
  MOV SI,[BP+8]
  DEC SI
  SHL SI,1
  MOV AX,[BP+6]
  AND AX,03Fh
  MOV VoiceVol[SI],AX
  POP BP
  RET 4
DQBsetVoiceVol ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBsetVolume
DQBsetVolume PROC
  PUSH BP
  MOV BP,SP
  CMP SoundActive,0
  JE EndSetVolume
  MOV DX,BaseAddr
  ADD DX,4
  MOV AL,022h
  OUT DX,AL
  INC DX
  MOV AX,[BP+6]
  AND AL,0Fh
  MOV BL,AL
  SHL BL,4
  OR AL,BL
  OUT DX,AL
EndSetVolume:
  POP BP
  RET 2
DQBsetVolume ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBinstallKeyboard
DQBinstallKeyboard PROC
  CMP KeyActive,1
  JE EndKeyInstall
  MOV AX,040h
  MOV GS,AX
  MOV SI,017h
  MOV AL,GS:[SI]
  AND AL,070h
  MOV KeyFlags,AL 
  PUSH DS
  MOV AX,3509h
  INT 21h
  POP DS
  MOV OldInt9seg,ES
  MOV OldInt9off,BX
  MOV AX,SEG KeyboardISR
  MOV DX,OFFSET KeyboardISR
  PUSH DS
  MOV DS,AX
  MOV AX,2509h
  INT 21h
  POP DS
  MOV KeyActive,1
  RET
KeyboardISR:
  PUSH AX
  PUSH BX
  PUSH SI
  PUSH DS
  MOV BL,1
  IN AL,60h
  TEST AL,80h
  JZ StoreStatus
  AND AL,7Fh
  MOV BL,0
StoreStatus:
  XOR AH,AH
  MOV SI,AX
  MOV AX,@DATA
  MOV DS,AX
  MOV KeyStatus[SI],BL
  IN AL,61h
  OR AL,80h
  OUT 61h,AL
  MOV AL,20h
  OUT 20h,AL
  POP DS
  POP SI
  POP BX
  POP AX
  IRET
EndKeyInstall:
  RET
DQBinstallKeyboard ENDP

; UUUUUUUUUUUUUUUUUUUUUUUUU

EVEN
PUBLIC DQBkey
DQBkey PROC
  PUSH BP
  MOV BP,SP
  XOR AH,AH
  MOV SI,[BP+6]
  CMP KeyStatus[SI],1
  SETE AL
  NEG AX
  POP BP
  RET 2
DQBkey ENDP

END
